#include <stdio.h>
#include <rasterfile.h>
#include <pixrect/pixrect.h>
#include <pixrect/pr_io.h>

/* reads a raster file (either standard or compressed) 
   in gray scle and compresses to pixmap */
#define THRESHOLD  32    /* gray to black threshold */

extern Pixrect * mem_create();

main(argc,argv)
int argc;
char *argv[];
{
Pixrect *image, *d_image;
FILE *input = stdin;
FILE *output = stdout;
colormap_t colormap;
int src_x,src_y,i,j;
int threshold = THRESHOLD;

if( argc == 2 ) {
      threshold = atoi(argv[1]);
      fprintf(stderr,"gray_to_pix: threshold set at %d\n",threshold);
      }
if( argc > 2 ) {
      fprintf(stderr,"usage: gray_to_pix [threshold value] \n");
      exit(2);
      }

colormap.type = RMT_NONE;
  
if(!(image = pr_load(input,&colormap))) {
  fprintf(stderr,"Load failure: File not an image?!\n");
  exit(1);
  }
if(colormap.type != RMT_EQUAL_RGB) {
  fprintf(stderr,"Error: not a grayscale image!\n");
  exit(2);
  }

src_x = image->pr_size.x;
src_y = image->pr_size.y;
d_image = mem_create(src_x,src_y,1);
  
for(i=0;i<src_y;i++) 
    for(j=0;j<src_x;j++) {
	if( pr_get(image,j,i) < threshold) pr_put(d_image,j,i,0);
	else pr_put(d_image,j,i,1);
	}

if( (pr_dump(d_image,output,&colormap,2,0)) ) {
	  fprintf(stderr,"file NOT written!");
	  exit(2);
	  }
exit(0);
}
