/* rotates an image through 90 degrees, including the arguemnet r or -r
   causes couterclockwise rotation */

#include <stdio.h>
#include <rasterfile.h>
#include <pixrect/pixrect.h>
#include <pixrect/pr_io.h>

extern Pixrect * mem_create();

main(argc,argv)
int argc;
char *argv[];
{
Pixrect *image, *d_image;
FILE *input = stdin;
FILE *output = stdout;
colormap_t colormap;
int i,j,reverse=0;
int x,y;
if( argc == 2 ) {
      fprintf(stderr,"counter-clockwise rotation\n");
      reverse=1;
      }
else { fprintf(stderr,"clockwise rotation\n"); }
colormap.type = RMT_NONE;
if( !(image = pr_load(input,&colormap)))
	exit(1);

if(colormap.type == RMT_EQUAL_RGB)
	exit(2);

x = image->pr_size.x;
y = image->pr_size.y;

d_image = mem_create( y,x,1 );
if(reverse == 0) {
 for(i=0; i < y; i++)
   for(j=0; j < x; j++) 
       pr_put(d_image,y-i-1,j,(pr_get(image,j,i)) );
 }
else {
 for(i=0; i < y; i++)
   for(j=0; j < x; j++) 
       pr_put(d_image,i,x-j-1,(pr_get(image,j,i)) );
 }

if ( pr_dump(d_image,output,colormap,RT_BYTE_ENCODED,0))
    fprintf(stderr,"rotate: failed\n");
exit(0);
}

