/* usage tif_to_pix filename1 filename2, converts tiff from Intel to Motorola/
   Sun uncompressed standard pixrect file */
/* version 2, handles scanned images aligned on 8 bit boundaries as opposed to
the required 16 bit boundaries needed by pixrects */
#include <stdio.h>
#include <fcntl.h>
#define PERMS 0666    /* -rw-rw-rw-  for file */
#define MINF    10    /* minimum valid tiff file size, actually more like 20 */
#define RESLEN   8    /* two longs for resolution */
#define LNG      4    /* long type as defined here (not in Unix) */
#define SHRT     2    /* short */
#define R_MAGIC 1504078485
#define REDGRNBLUE 1

char buf1[BUFSIZ];    /* BUFSIZ defined in syscalls.h */
char buf2[BUFSIZ]; 
int dpn,dp; /* pointer and number of data array   */
int lpn,lp; /* pointer and number of length array */
int xp,yp;  /* offsets to x,y resolution */
int bitsperpix, rows_per_strip;

struct rasfile {
 int ras_magic;
 int ras_width;
 int ras_height;
 int ras_depth;
 int ras_length;
 int ras_type;
 int ras_maptype;
 int ras_maplength;
 }   rast;

main(argc,argv)
int argc;
char *argv[];
{
int f1,f2;  /* file descriptors */
int a,b;
long datastart;
int offset,inc,r,c,i,j,k,l,m,n,u,ii; /* offset is the pointer into the data strip, to allow
                                        one full row of data (%16bits) to be written */
int n1,n2;  /* current size of data in buf1 buf2 */
int ifd;    /* location of IFD */
int ifdlen; /* length of ifd, ifd plus offset to next is ifdlen+4 */
int s;      /* tag */
char *p,*bp;  
unsigned char cc;
int *dpbuf,*lpbuf;
long lseek();
char *buf3;
if( argc != 3)
   fprintf(stderr,"tif_to_pix: missing filename arguements"); 
if( (f1 = open(argv[1], O_RDONLY, 0)) == -1)
   fprintf(stderr,"tif_to_pix: can't open %s", argv[1]);
if( (f2 = creat(argv[2], PERMS )) == -1)
   fprintf(stderr,"tif_to_pix: can't create %s", argv[2]);

if( (n1=read(f1,buf1,BUFSIZ)) <= MINF ) 
    fprintf(stderr,"tif_to_pix: empty or invalid input");

if( buf1[0] != 'I' ) printf("bad input file, first char should be -I- \n");
if( buf1[2] != 42 ) {
       printf("bad input file, wrong version?? \n");
       exit(2);
       }

ifd = get_int(&buf1[4]);  /* get IFD offset */

if( lseek(f1, (long) ifd, 0) <= 0L ) fprintf(stderr,"tif_to_pix: seek error");
if( (n2=read(f1,buf2,BUFSIZ)) == BUFSIZ )
    fprintf(stderr,"tif_to_pix: conversion algorythm failed (too many IFD's?)");

j=0;                      /* j is the bufer index */
s = get_short(&buf2[j]);  /* get num of IFD fields */
j+=2;
ifdlen = j + s*12;        /* get end of IFD, check for end */
m = s;
/* printf("Number of fields in IFD %d\n",m); */
if ( (s=get_int(&buf2[ifdlen])) != 0 ) 
    fprintf(stderr,"tif_to_pix: offset to new IFD exists, NOT handled!\n");

/**************************IFD*************************************/
for( l = 0; l < m; l++)
	{
	/* fprintf(stderr,"j: %d\n",j); */
	s = get_short(&buf2[j]);
	j += 2;
	if( (s < 254) || (s > 296) )
	   fprintf(stderr,"field tag out of range: %d\n",s);
	bigswitch(s,j);
	j +=10;
	}
/*************************END IFD***********************************/
     
/*************************RESOLUTION********************************/
if( lseek(f1, (long) xp, 0) <= 0L ) 
    fprintf(stderr,"tif_to_pix: seek error for resolution");
if( read(f1,buf2,RESLEN) != RESLEN) 
    fprintf(stderr,"tif_to_pix: read failure for resolution!\n");
a=get_int(&buf2[0]);
b=get_int(&buf2[4]);
fprintf(stderr,"x-resolution %d dpi\n",a/b);

if( lseek(f1, (long) yp, 0) <= 0L ) 
    fprintf(stderr,"tif_to_pix: seek error for resolution");
if( read(f1,buf2,RESLEN) != RESLEN) 
    fprintf(stderr,"tif_to_pix: read failure for resolution!\n");
a=get_int(&buf2[0]);
b=get_int(&buf2[4]);
fprintf(stderr,"y-resolution %d dpi\n",a/b);
/*********************END RESOLUTION*********************************/

/***********************data and length pointers*********************/
if( lpn != dpn ) fprintf(stderr,"errror12");

dpbuf = (int *) malloc( dpn*sizeof(int) );
   if( lseek(f1, (long) dp, 0) <= 0L ) 
       fprintf(stderr,"tif_to_pix: data pointer seek error");
   for(i=0; i < dpn; i++) {
      if ( (r= read(f1,(dpbuf+i),LNG)) != LNG ) fprintf(stderr,"error10\n"); 
      j = get_int(dpbuf+i);  /* actually just flip dpbuf */
      }
        
lpbuf = (int *) malloc( lpn*sizeof(int) ); 
   if( lseek(f1, (long) lp, 0) <= 0L ) 
       fprintf(stderr,"tif_to_pix: length pointer seek error");
   for(i=0; i < lpn; i++) {
      if ( (r= read(f1,lpbuf+i,LNG)) != LNG ) fprintf(stderr,"error11\n"); 
      j = get_int(lpbuf+i);  /* actually just flip lpbuf */
      }

   rast.ras_length = 0;
   if ( bitsperpix == 1 ) datastart = 32L;
   else datastart = 800L;   /* grey scale needs color map of 768 */
   if( lseek(f2, datastart, 0) != datastart ) 
       fprintf(stderr,"tif_to_pix: seek error14");
   j = *(lpbuf); 
   buf3 = (char *) malloc( j+10);
   for(i=0; i < lpn; i++) {
      lseek(f1,(long) *(dpbuf+i),0);  
      k = *(lpbuf+i); 
      if( k > j+9) fprintf(stderr,"buffer overflow\n");
      if ( (r= read(f1,buf3,k )) != k) 
				 fprintf(stderr,"error16\n"); 
	k = 0;
	offset = 0;
	inc = rast.ras_width/8;
	if( (rast.ras_width %8) != 0) {
					inc += 1;
				fprintf(stderr,"\nWARNING, scan image is not divisble by 8\n");
				fprintf(stderr,"tiff to pix translation will be wrong!\n");
					}
	if( (inc%2) != 0 )           inc += 1;
        for( ii=0 ; ii < rows_per_strip; ii++) {
			if ( (r= write(f2,buf3 + offset,inc)) != inc)
                                 fprintf(stderr,"error17\n");
			offset += rast.ras_width/8;
			k += inc;
/* fprintf(stderr,"i, offset, inc, k %d %d %d %d\n", ii,offset,inc,k); */
		        }
      rast.ras_length += k;
      }

/**************************end data**********************************/

/***************************HEADER***********************************/
rast.ras_magic = R_MAGIC;
rast.ras_type = 1;
rast.ras_maptype = 0;
rast.ras_maplength = 0;
if( bitsperpix == 8) {
      fprintf(stderr,"\nWARNING, gray-scale conversion.  (has not been fully debugged)\n");
      rast.ras_maptype = 1;
      rast.ras_maplength = 768;
      if( lseek(f2,32L, 0) < 0L ) 
          fprintf(stderr,"tif_to_pix: seek error");
      for( i=0; i<3; i++) 
	  for(j=0;j < 256;j++) {
	      cc = (unsigned char) j*4; /* NOTE, that this is a kludge
			    based on the 64 level grey scale of the 
			    scanner (64*4 = 256)    */
              if( write(f2,&cc,1) != 1 )  /* */
                      fprintf(stderr,"tif_to_pix: write failure !\n");
	      }
      }

if( lseek(f2, (long) 0, 0) < 0L ) 
          fprintf(stderr,"tif_to_pix: seek error");
if( write(f2, (char *) &rast,32) != 32 )  /* first 32 bytes */
          fprintf(stderr,"tif_to_pix: write failure !\n");
/*************************end Header*********************************/
}

get_int(b)
char *b;
{
int n;
char *p;
p = (char *) &n;
flip(b,4);
*p = *b; *(p+1) = *(b+1); *(p+2) = *(b+2); *(p+3)=*(b+3);
return(n);
}

get_short(b) /* actually returns an int */
char *b;
{
short n;
char *p;
p = (char *) &n;
flip(b,2);
*p = *b; *(p+1) = *(b+1); 
return( (int) n);
}

flip(a,n)
/* flip inverts the order of bytes of -a-, n is sizeof(a) */
char *a;
int n;
{

  char t;
  t = *a;
  *a = *(a+(--n));
  *(a+n) = t;
  if( n < 2) return;
  flip( a+1,--n);
}



bigswitch(s,j)
int s,j;
{
  int r,u;
  switch (s) {
	  case 254:  /* ? */
	     if( get_short(&buf2[j]) != 4 ) 
		     fprintf(stderr,"tag %d expected integer type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"tag %d expected value not offset\n",s);
	     j += 4;
	     get_int(&buf2[j]);
	     /* fprintf(stderr,"tag %d read\n",s); */
	     j += 4;
	     break;
	  case 256: /* image width */
	     if( get_short(&buf2[j]) != 4 ) /* tiff actually expects a short! */
		     fprintf(stderr,"tag %d expected integer type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"tag %d expected value not offset\n",s);
	     j += 4;
	     r=get_int(&buf2[j]);
	     fprintf(stderr,"image width: %d\n",r);
	     rast.ras_width = r;
	     j += 4;
	     break;
	  case 257: /* image height */
	     if( get_short(&buf2[j]) != 4 ) /* tiff actually expects a short! */
		     fprintf(stderr,"tag %d expected integer type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"tag %d expected value not offset\n",s);
	     j += 4;
	     r=get_int(&buf2[j]);
	     fprintf(stderr,"image height: %d\n",r);
	     rast.ras_height = r;
	     j += 4;
	     break;
	  case 258: /* Bits per sample */
	     if( get_short(&buf2[j]) != 3 ) 
		     fprintf(stderr,"tag %d expected short type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"tag %d expected only 1 samplperpixel\n",s);
	     j += 4;
	     bitsperpix=get_short(&buf2[j]);
	     fprintf(stderr,"bits per sample: %d\n",bitsperpix);
	     rast.ras_depth = bitsperpix;
	     j += 4;
	     break;
	  case 259: /* data compression type */
	     if( get_short(&buf2[j]) != 3 ) 
		     fprintf(stderr,"tag %d expected short type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"tag %d expected value not offset\n",s);
	     j += 4;
	     u=get_short(&buf2[j]);
	     fprintf(stderr,"data compression style: %x\n",u);
	     if( u != 1) 
		  fprintf(stderr,"Warning: data compression not handled\n");
	     j += 4;
	     break;
	  case 262: /* white is min or max val */
	     if( get_short(&buf2[j]) != 3 ) 
		     fprintf(stderr,"tag %d expected short type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"tag %d expected value not offset\n",s);
	     j += 4;
	     u=get_short(&buf2[j]);
	     fprintf(stderr,"data normal/reverse (0/1): %d\n",u);
	     j += 4;
	     break;
	  case 273: /* pointer to the pointer array for the data */
	     if( get_short(&buf2[j]) != 4 ) 
		     fprintf(stderr,"tag %d expected integer type\n",s);
	     j +=2;
	     dpn=get_int(&buf2[j]);
	     j += 4;
	     dp=get_int(&buf2[j]);
	     /* fprintf(stderr,
		     "data pointer offset %d, number of strips %d\n",dp,dpn);*/
	     fprintf(stderr, "number of data strips %d\n",dpn);
	     j += 4;
	     break;
	  case 278:  /* rows per strip */
	     if( get_short(&buf2[j]) != 4 ) 
		     fprintf(stderr,"tag %d expected integer type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"tag %d expected value not offset\n",s);
	     j += 4;
	     r=get_int(&buf2[j]) ;
	     fprintf(stderr,
		     "rows per strip %d\n",r);
		rows_per_strip = r;
	     j += 4;
	     break;
	  case 279: /* pointer to StripByte counts */
	     if( get_short(&buf2[j]) != 4 ) 
		     fprintf(stderr,"tag %d expected integer type\n",s);
	     j +=2;
	     lpn=get_int(&buf2[j]);
	     j += 4;
	     lp=get_int(&buf2[j]);
	     /* fprintf(stderr,
		     "length offset %d, number of strips %d\n",lp,lpn);*/
	     j += 4;
	     break;
	  case 282: /* X resolution */
	     if( get_short(&buf2[j]) != 5 ) 
		     fprintf(stderr,"tag %d expected rational type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"X-resolution tag expects only 1 value\n");
	     j += 4;
	     xp=get_int(&buf2[j]);
	     /* fprintf(stderr,
		     "x-res pointer offset %d\n",xp); */
	     j += 4;
	     break;
	  case 283: /* Y resolution */
	     if( get_short(&buf2[j]) != 5 ) 
		     fprintf(stderr,"tag %d expected rational type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1)
		     fprintf(stderr,"Y-resolution tag expects only 1 value\n");
	     j += 4;
	     yp=get_int(&buf2[j]);
	     /* fprintf(stderr,
		     "y-res pointer offset %d\n",yp); */
	     j += 4;
	     break;
	  case 284: /* Planarconfig */
	     if( get_short(&buf2[j]) != 3 ) 
		     fprintf(stderr,"tag %d expected short type\n",s);
	     j +=2;
	     if( get_int(&buf2[j]) != 1 )
		     fprintf(stderr,"Planar config, only accepts N of 1\n");
	     j += 4;
	     u=get_short(&buf2[j]);
	     fprintf(stderr,
		     "planar configuration %d\n",u);
	     j += 4;
	     break;
          default:
	     fprintf(stderr,"Unknown tag %d\n",s);
	     j += 10;
	     break;
          }
}



