
/*
version 8, dec 20 , 92.. most of the fancy stuff has been stripped to run
under V2 of openwin (and therefore on a SUN 3??)
(Written by Neil Humphrey, Univ. of Wyoming, neil@auk.uwyo.edu)
 */

#include <stdio.h>
#ifdef	SUNOS
#include <rasterfile.h>
#else
#include <raster.h>
#endif
#include <string.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/notice.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/scrollbar.h>
#include <pixrect/pr_io.h>
#include <pixrect/pixrect.h>
#include "nxscan_ui.h"
#include "nxscan.h"
#include "SAC.h"
#include "load_choser.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>   /* needed for the timer, for the flashing */



/* * Global object definitions.  */
nxscan_win_objects		*Nxscan;
nxscan_locate_popup_objects	*Nxscan_locate_popup;
nxscan_tools_popup_objects	*Nxscan_tools_popup;
nxscan_user_termpane_objects	*Nxscan_user_termpane;
nxscan_save_popup_objects	*Nxscan_save_popup;

Attr_attribute	INSTANCE;

void    select_format_SAC();
void    select_format_usr();
Notify_value ndestroy_func();
Notify_value  scroll_monitor();
Notify_value  notify_drawbox();
Notify_value  notify_flash_line();
void    drawbox();
void    nxscan_initialize();
void    nxscan_file_close();
int     nxscan_file_load();
int     nxscan_file_save();
 
/* client structures that contain info on server */
static Display     *dpy;           /* X display */
static XImage     *xim2;           /* pointer to client Image of canvas2 */
static Visual  *dvisual;           /* default *visual */
/* Xlib handles */
static XVisualInfo xvis;           /* X visual (from Xmatch) ID */
static int       xclass;           /* class of visual */
static int    dscreen_n;           /* default screen number */
static GC           gc_solid,gc_dashed,gc_invert;           /* gc for canvass   */
static XID          xid;           /* X id of xv canvas,drawable */
static XID          xid1;          /* X id of xv canvas1,drawable */
static XID          xid_locate;          /* X id of xv canvas2,drawable */
 
Scrollbar     hbar,vbar;
struct itimerval  timer,timer2;

struct SAChead SAC_head;

void
main(argc, argv)
    int	argc;
    char	**argv;
{
    /* * Initialize XView.  */
    xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
    INSTANCE = xv_unique_key();
	
    nxscan_initialize(NULL);

	/* * Turn control over to XView.  */
    xv_main_loop(Nxscan->win);
    exit(0);
}

/* * Initialize nxscan module, NOTE do not do any drawing in this routine, since
the notifier has not yet been started!  */
void
nxscan_initialize(owner)
    Xv_opaque       owner;
{
    XFontStruct   *font;
    XGCValues     gc_val;
 
    Nxscan = nxscan_win_objects_initialize(NULL, NULL);
    Nxscan_locate_popup = nxscan_locate_popup_objects_initialize(NULL, Nxscan->win);
    Nxscan_tools_popup = nxscan_tools_popup_objects_initialize(NULL, Nxscan->win);
    Nxscan_user_termpane = nxscan_user_termpane_objects_initialize(NULL, Nxscan->win);
    Nxscan_save_popup = nxscan_save_popup_objects_initialize(NULL, Nxscan->win);
    load_initialize(Nxscan->win);
    save_initialize(Nxscan->win);
    SAC_initialize(Nxscan->win);
    timepoint[0]= -999;
    timepoint[1]= -998;
    erase_dat.pending = 0;

    xv_set(Nxscan->canvas,
	   CANVAS_AUTO_SHRINK, FALSE,
	   CANVAS_AUTO_EXPAND, TRUE,
	   CANVAS_X_PAINT_WINDOW, TRUE,
	   0);
    xv_set(Nxscan->canvas1,
	   CANVAS_AUTO_SHRINK, FALSE,
	   CANVAS_AUTO_EXPAND, TRUE,
	   CANVAS_X_PAINT_WINDOW, TRUE,
	   0);
    xv_set(Nxscan_locate_popup->locate_canvas,
	   CANVAS_AUTO_SHRINK, FALSE,
	   CANVAS_AUTO_EXPAND, TRUE,
	   CANVAS_X_PAINT_WINDOW, TRUE,
	   0);
    notify_interpose_destroy_func(Nxscan->win,ndestroy_func);
    hbar = (Scrollbar) xv_get(Nxscan->canvas, WIN_HORIZONTAL_SCROLLBAR);
    vbar = (Scrollbar) xv_get(Nxscan->canvas, WIN_VERTICAL_SCROLLBAR);

/*      notify_interpose_event_func(xv_get(hbar,SCROLLBAR_NOTIFY_CLIENT), 
	scroll_monitor, NOTIFY_SAFE);  */

    /* set Xlib handles, uses default screen and visual */
    dpy = (Display *) xv_get(Nxscan->canvas,XV_DISPLAY);
    xid = (XID)       xv_get(canvas_paint_window(Nxscan->canvas)
			     , XV_XID);
    xid1 = (XID)      xv_get(canvas_paint_window(Nxscan->canvas1)
			     , XV_XID);
    xid_locate =(XID) xv_get(canvas_paint_window(Nxscan_locate_popup->locate_canvas)
			     , XV_XID);
    dscreen_n =       XDefaultScreen(dpy);
    dvisual =         XDefaultVisual(dpy,dscreen_n);
    gc_dashed  =      XCreateGC(dpy,xid,0,NULL);
/* make dashed line contrast with the existing pixels */
    XSetFunction( dpy, gc_dashed, GXinvert);

    if(!(font =       XLoadQueryFont(dpy, "fixed")) ) {
	puts("Cannot load fixed font?? [fatal error]");
	exit(1);
    }
    gc_val.font =     font->fid;
    gc_solid    =     XCreateGC(dpy,xid,GCFont,&gc_val);
    gc_invert    =     XCreateGC(dpy,xid,GCFont,&gc_val);
    /* set forground and back ground */
    XSetForeground( dpy, gc_solid, WhitePixel(dpy, dscreen_n) );
    XSetForeground( dpy, gc_invert, BlackPixel(dpy, dscreen_n) );
    XSetForeground( dpy, gc_dashed, WhitePixel(dpy, dscreen_n) );
    XSetBackground( dpy, gc_solid, BlackPixel(dpy, dscreen_n) );
    XSetBackground( dpy, gc_invert, WhitePixel(dpy, dscreen_n) );
    XSetBackground( dpy, gc_dashed, BlackPixel(dpy, dscreen_n) );

/* put one-time initializartions here */
    locate_dat.loc_to_main_ratio = 1;
    tr = NULL;
    tr2 = NULL;
}


/*
 * Menu handler for `file_menu (Load...)'.
 */
Menu_item
nxscan_load_handler(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    switch (op) {
    case MENU_DISPLAY:
	break;

    case MENU_DISPLAY_DONE:
	break;

    case MENU_NOTIFY:
	xv_set(Load_choser->load_popup, XV_SHOW, TRUE, NULL);
	break;

    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}
 
/*
 * Menu handler for `file_menu (save)'.
 */
Menu_item
file_save_callback(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    switch (op) {
    case MENU_DISPLAY:
	xv_set(item, MENU_INACTIVE, Pr_c == NULL, 0);
	break;

    case MENU_DISPLAY_DONE:
	break;

    case MENU_NOTIFY:
	xv_set(Nxscan_save_popup->save_popup, FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
	xv_set(Nxscan_save_popup->save_popup, XV_SHOW, TRUE, NULL);
	xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,
	       "Waiting for selection", NULL);
	break;

    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for `file_menu (close)'.
 */
Menu_item
nxscan_close_handler(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    nxscan_win_objects * ip = (nxscan_win_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if( !Pr_c ) return item;
    switch (op) {
    case MENU_DISPLAY:
	xv_set(item, MENU_INACTIVE, Pr_c == NULL, 0);
	break;

    case MENU_DISPLAY_DONE:
	break;

    case MENU_NOTIFY:
	nxscan_file_close();
	break;

    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for `magnify_menu (magnify)'.
 */
Menu_item
mag_handler(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    if( !Pr_c ) return item;
    switch (op) {
    case MENU_DISPLAY:
	break;
    case MENU_DISPLAY_DONE:
	break;
    case MENU_NOTIFY:
	if( canvas_dat.pix == 0 ) { set_message7("At maximum magnification"); return item;}
	if ( Pr[canvas_dat.pix - 1] == NULL )  {
	    set_message7("max mag. result of oversize pixrect"); return item;}
	canvas_dat.pix -= 1;
	Pr_c = Pr[canvas_dat.pix];
	locate_dat.loc_to_main_ratio *= 2;
	resize_load( 2 * xv_get(hbar, SCROLLBAR_VIEW_START) + 
		     locate_dat.box_size_x*locate_dat.loc_to_main_ratio/2,
		     2 * xv_get(vbar, SCROLLBAR_VIEW_START) + 
		     locate_dat.box_size_y*locate_dat.loc_to_main_ratio/2);
	break;

    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for `magnify_menu (reduce)'.
 */
Menu_item
reduce_handler(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    if( !Pr_c ) return item;
    switch (op) {
    case MENU_DISPLAY:
	break;
    case MENU_DISPLAY_DONE:
	break;
    case MENU_NOTIFY:
	if( (canvas_dat.pix += 1) > 9 || Pr[canvas_dat.pix] == NULL ||
	    (locate_dat.loc_to_main_ratio / 2) == 0 ) { 
	    canvas_dat.pix -= 1;
	    set_message7("At minimum reduction"); 
	    return item;
	}
	Pr_c = Pr[canvas_dat.pix];
	locate_dat.loc_to_main_ratio /= 2;
	resize_load( 
	    xv_get(hbar, SCROLLBAR_VIEW_START)/2  - 
	    locate_dat.box_size_x*locate_dat.loc_to_main_ratio,  
	    xv_get(vbar, SCROLLBAR_VIEW_START)/2  -
	    locate_dat.box_size_y*locate_dat.loc_to_main_ratio); 
	break;
    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for `magnify_menu (redraw)'.
 */
Menu_item
redraw_handler(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    if( !Pr_c ) return item;
    switch (op) {
    case MENU_DISPLAY:
	break;
    case MENU_DISPLAY_DONE:
	break;
    case MENU_NOTIFY:
	resize_load(  xv_get(hbar, SCROLLBAR_VIEW_START), 
		      xv_get(vbar, SCROLLBAR_VIEW_START));
	break;
    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for `options_menu (locator pop-up)'.
 */
Menu_item
nxscan_options_menu_item0_callback(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    nxscan_win_objects * ip = (nxscan_win_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    switch (op) {
    case MENU_DISPLAY:
	break;

    case MENU_DISPLAY_DONE:
	break;

    case MENU_NOTIFY:
	xv_set(Nxscan_locate_popup->locate_popup, FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
	xv_set(Nxscan_locate_popup->locate_popup, XV_SHOW, TRUE, NULL);
	break;

    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for `options_menu (tools pop-up)'.
 */
Menu_item
nxscan_options_menu_item1_callback(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    nxscan_win_objects * ip = (nxscan_win_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    switch (op) {
    case MENU_DISPLAY:
	break;

    case MENU_DISPLAY_DONE:
	break;

    case MENU_NOTIFY:
	xv_set(Nxscan_tools_popup->tools_popup, XV_SHOW, TRUE, NULL);
	break;

    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}
 
/*
 * Menu handler for `file_menu (exit)'.
 */
Menu_item
exit_handler(item, op)
    Menu_item       item;
    Menu_generate   op;
{
    nxscan_win_objects * ip = (nxscan_win_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
        
    switch (op) {
    case MENU_DISPLAY:
	break;
 
    case MENU_DISPLAY_DONE:
	break;
 
    case MENU_NOTIFY:
	/* fputs("nxscan: exit_handler: MENU_NOTIFY\n", stderr); */
	quit(Nxscan->win);
 
	break;
 
    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for `options_menu (unix shell)'.
 */
Menu_item
nxscan_options_menu_item2_callback(item, op)
    Menu_item	item;
    Menu_generate	op;
{
    nxscan_win_objects * ip = (nxscan_win_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    switch (op) {
    case MENU_DISPLAY:
	break;

    case MENU_DISPLAY_DONE:
	break;

    case MENU_NOTIFY:
	xv_set(Nxscan_user_termpane->user_termpane, XV_SHOW, TRUE, NULL);
	break;

    case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Notify callback function for `mag_button'.
 */
void
nxscan_win_mag_button_notify_callback(item, event)
    Panel_item	item;
    Event		*event;
{
    if( !Pr_c ) return;
    /* fputs("nxscan: nxscan_win_mag_button_notify_callback\n", stderr); */
    xv_set(Nxscan->mag_button, XV_SHOW, TRUE, NULL);
}

/*
 * Notify callback function for `options_button'.
 */
void
options_handler(item, event)
    Panel_item	item;
    Event		*event;
{
    nxscan_win_objects *ip = (nxscan_win_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    /* fputs("nxscan: options_handler\n", stderr); */
}

/*
 * Event callback function for `canvas'.
 */
Notify_value
canvas_event_nhandler(win, event, arg, type)
    Xv_window	win;
    Event		*event;
    Notify_arg	arg;
    Notify_event_type type;
{
    if( !Pr_c ) return NOTIFY_DONE;
    if ( event_action(event) == LOC_WINENTER )  {
	/*start flashing*/
	timer2.it_value.tv_usec   = 200000;
	timer2.it_interval.tv_usec= 200000;
	notify_set_itimer_func(win,notify_flash_line, ITIMER_REAL, &timer2, NULL);
    }
    if ( event_action(event) == LOC_WINEXIT )  {
	/*stop flashing*/
	notify_set_itimer_func(win,NOTIFY_FUNC_NULL, ITIMER_REAL, NULL, NULL);
    }

    if ( (event_action(event) == ACTION_SELECT) && event_is_down(event) ) {
	set_message4(event_x(event), event_y(event));
	if( timeflag != 0 ) {
	    timepoint[timeflag-1] = 
		event_x(event)*canvas_dat.reduction;
	    if(timeflag == 2) {
		char b[50];
		int dif;
		dif = timepoint[1]-timepoint[0];
		sprintf(b,"%d",dif);
		xv_set(Save_SAC->pix_dif, PANEL_VALUE, b, 0);  
	    }
	    if(timeflag <= 5) { /* put vertical line */
		if(oldtimeflag != 0) {
		    XDrawLine(dpy,xid,gc_dashed,oldtimelinex,
			      oldtimeliney-50,oldtimelinex,
			      oldtimeliney+50);
		    XDrawLine(dpy,xid,gc_dashed,oldtimelinex-50,
			      oldtimeliney,oldtimelinex+50,
			      oldtimeliney);
		}	
		XDrawLine(dpy,xid,gc_dashed,event_x(event),
			  event_y(event)-50,event_x(event),
			  event_y(event)+50);
		XDrawLine(dpy,xid,gc_dashed,event_x(event)-50,
			  event_y(event),event_x(event)+50,
			  event_y(event));
		oldtimelinex = event_x(event);
		oldtimeliney = event_y(event);
		oldtimeflag = 1;
	    }

	    if(timeflag == 4) {
		baselinex1 = event_x(event) * canvas_dat.reduction;
		baseliney1 = event_y(event) * canvas_dat.reduction;
	    }
	    if(timeflag == 5) {
		baselinex2 = event_x(event) * canvas_dat.reduction;
		baseliney2 = event_y(event) * canvas_dat.reduction;
	    }
                                                       
	    timeflag = 0;
	    return NOTIFY_DONE;
	}
	add_usr_point(event_x(event), event_y(event));
	if( line_on == 1) notify_flash_line();
	tracef = 0;
	return NOTIFY_DONE;
    }  
    if ( (event_action(event) == ACTION_ADJUST) && event_is_down(event) ) {
	set_message4(event_x(event), event_y(event));
	if( line_on == 1) notify_flash_line();
	tracef = 1;
	return NOTIFY_DONE;
    }
    if ( (event_action(event) == ACTION_ADJUST) && event_is_up(event) ) {
	set_message4(event_x(event), event_y(event));
	if( line_on == 1) notify_flash_line();
	tracef = 0;
	return NOTIFY_DONE;
    }
    if ( (event_action(event) == ACTION_MENU) && event_is_down(event) ) {
	set_message4(event_x(event), event_y(event));
	if( canvas_dat.addf == 0) return NOTIFY_DONE;
	erase( event_x(event), event_y(event), 0 );
	return NOTIFY_DONE;
    }

    return notify_next_event_func(win, (Notify_event) event, arg, type);
}

Notify_value
notify_flash_line()
{
    if( !Pr_c ) return NOTIFY_DONE;
    if ( tracef == 0) show_userlist();
    else show_trace();
    return NOTIFY_DONE;
}

set_message4(ex,ey)
    int ex,ey;
{
    sprintf(message4loc,"%5dx%5d",ex,ey);
    xv_set(Nxscan->message4,PANEL_LABEL_STRING,message4loc,NULL);
    sprintf(message6loc,"%5dx%5d",ex*image_dat.xresolution/canvas_dat.res,
	    ey*image_dat.xresolution/canvas_dat.res);
    xv_set(Nxscan->message6,PANEL_LABEL_STRING,message6loc,NULL);
}

/*
 * Event callback function for `locate_canvas'.
 */
Notify_value
locate_canvas_e_handler(win, event, arg, type)
    Xv_window	win;
    Event		*event;
    Notify_arg	arg;
    Notify_event_type type;
{

    int tx,ty,tox,toy;
    int maxx,maxy;

    nxscan_locate_popup_objects *ip = (nxscan_locate_popup_objects *) xv_get(xv_get(win, 
										    CANVAS_PAINT_CANVAS_WINDOW), XV_KEY_DATA, INSTANCE);
    if( !Pr_c ) return NOTIFY_DONE;
    if ( (event_action(event) == ACTION_SELECT) && event_is_down(event) ) {
	locate_dat.new_box_x = event_x(event);
	locate_dat.new_box_y = event_y(event);
/* this form of return, kills all events at this point if Pr_c == NULL */
	if ( locate_dat.box_exposed == 1 ) 
	    drawbox( dpy, xid_locate , gc_dashed ,locate_dat.old_box_x,
		     locate_dat.old_box_y,2*locate_dat.box_size_x,2*locate_dat.box_size_y); 
	/*erase old box */

	locate_dat.box_size_x = 
	    canvas_dat.win_w /(2*locate_dat.loc_to_main_ratio);
	locate_dat.box_size_y = 
	    canvas_dat.win_h /(2*locate_dat.loc_to_main_ratio);
	if( locate_dat.new_box_x < locate_dat.box_size_x ) 
	    locate_dat.new_box_x = locate_dat.box_size_x;
	if( locate_dat.new_box_y < locate_dat.box_size_y ) 
	    locate_dat.new_box_y = locate_dat.box_size_y;
	maxx = canvas_dat.canvas_w/locate_dat.loc_to_main_ratio - locate_dat.box_size_x; 
	maxy = canvas_dat.canvas_h/locate_dat.loc_to_main_ratio - locate_dat.box_size_y; 
	if( locate_dat.new_box_x > maxx ) locate_dat.new_box_x = maxx;
	if( locate_dat.new_box_y > maxy ) locate_dat.new_box_y = maxy;
/*fprintf(stderr,"canvasw %d, boxx %d ratio %d maxx %d\n",canvas_dat.win_w,locate_dat.box_size_x,
  locate_dat.loc_to_main_ratio);*/
	tox = locate_dat.old_box_x; 
	toy = locate_dat.old_box_y; 
	locate_dat.old_box_x = locate_dat.new_box_x; 
	locate_dat.old_box_y = locate_dat.new_box_y;
	locate_dat.box_exposed = 1;
	drawbox( dpy, xid_locate , gc_dashed ,locate_dat.new_box_x,locate_dat.new_box_y,
		 2*locate_dat.box_size_x,2*locate_dat.box_size_y); 
	xv_set(hbar, SCROLLBAR_VIEW_START,
	       (locate_dat.new_box_x-locate_dat.box_size_x) *locate_dat.loc_to_main_ratio , 0);
	xv_set(vbar, SCROLLBAR_VIEW_START, 
	       (locate_dat.new_box_y-locate_dat.box_size_y) *locate_dat.loc_to_main_ratio , 0);
    }
    else if ( event_action(event) == LOC_WINENTER )  {
	if( locate_dat.box_exposed == 1) 
	    drawbox( dpy, xid_locate , gc_dashed ,locate_dat.old_box_x,
		     locate_dat.old_box_y,2*locate_dat.box_size_x,2*locate_dat.box_size_y); 
	locate_dat.box_exposed = 0;
	locate_dat.box_size_x = 
	    canvas_dat.win_w /(2*locate_dat.loc_to_main_ratio);
	locate_dat.box_size_y = 
	    canvas_dat.win_h /(2*locate_dat.loc_to_main_ratio);
	canvas_dat.scroll_x = (int) xv_get(hbar, SCROLLBAR_VIEW_START);
	canvas_dat.scroll_y = (int) xv_get(vbar, SCROLLBAR_VIEW_START);
	locate_dat.new_box_x = canvas_dat.scroll_x/locate_dat.loc_to_main_ratio
	    + locate_dat.box_size_x;
	locate_dat.new_box_y = canvas_dat.scroll_y/locate_dat.loc_to_main_ratio
	    + locate_dat.box_size_y;
	locate_dat.old_box_x = locate_dat.new_box_x; 
	locate_dat.old_box_y = locate_dat.new_box_y;
	/*start flashing*/
	timer.it_value.tv_usec   = 100000;
	timer.it_interval.tv_usec= 100000;
	notify_set_itimer_func(win,notify_drawbox, ITIMER_REAL, &timer, NULL);
    }
    else if ( event_action(event) == LOC_WINEXIT )  {
	/*stop flashing*/
	notify_set_itimer_func(win,NOTIFY_FUNC_NULL, ITIMER_REAL, NULL, NULL);
    }
	
    return notify_next_event_func(win, (Notify_event) event, arg, type);
}

Notify_value
notify_drawbox()
{
    if( !Pr_c ) return NOTIFY_DONE;
    locate_dat.box_exposed = ++locate_dat.box_exposed % 2;
    drawbox( dpy, xid_locate , gc_dashed , 
	     locate_dat.old_box_x,locate_dat.old_box_y,
	     2*locate_dat.box_size_x,2*locate_dat.box_size_y); 
    return NOTIFY_DONE;
}

void
drawbox( display, xw , gc ,x1,x2,x3,x4) /* draws centered box */
    Display    *display;
    Window      xw;
    GC          gc;
    int x1,x2,x3,x4;
{
    if( !Pr_c ) return ;
    XDrawRectangle( display, xw , gc , x1 - x3/2,x2-x4/2,x3,x4);
}

/*
 * Notify callback function for `setting3'.
 */
void
setting1_nhandler(item, value, event)
    Panel_item	item;
    int		value;
    Event		*event;
{
    switch(value) {
    case 0:
        fputs("nXscan: force_buttonr\n", stderr);
        insert_p=2;
        break;
    case 1:
        fputs("nXscan: insert_buttonr\n", stderr);
        insert_p=1;
        break;
    case 2:
        fputs("nXscan: del_buttonr\n", stderr);
        insert_p=0;
        break;
    default:
        fputs("nXscan: error in selection mechanism\n", stderr);
        break;
    }


}

/*
 * Notify callback function for `setting2'.
 */
void
add_nhandler(item, value, event)
    Panel_item	item;
    int		value;
    Event		*event;
{
    switch(value) {
    case 0:
        canvas_dat.addf = -192;
        break;
    case 1:
        canvas_dat.addf = -48;
        break;
    case 2:
        canvas_dat.addf = -12;
        break;
    case 3:
        canvas_dat.addf = -3;
        break;
    case 4:
        canvas_dat.addf = 0;
        break;
    case 5:
        canvas_dat.addf = 3;
        break;
    case 6:
        canvas_dat.addf = 12;
        break;
    case 7:
        canvas_dat.addf = 48;
        break;
    case 8:
        canvas_dat.addf = 192;
        break;
    default:
        fputs("nXscan: error in add mechanism\n", stderr);
        break;
    }
}

/*
 * Notify callback function for `slider2'.
 */
void
slider_nhandler(item, value, event)
    Panel_item	item;
    int		value;
    Event		*event;
{
    curvature = value;
}

/*
 * Notify callback function for `dig_but1'.
 */
void
digitze_handler(item, event)
    Panel_item	item;
    Event		*event;
{
    int j;
    fputs("nxscan: digitze_handler\n", stderr);
    if( line_on == 1) notify_flash_line();
    tracef = 1;
	
    erase_mem(0);
    error_dump();
    trace(xim[canvas_dat.maxpix],user_p,user_cf,user_n);
}

void 
undo_add_handler(item, event) 
    Panel_item      item; 
    Event           *event; 
{ 
    if( erase_dat.pending == 0) return;
    erase_dat.pending = 0;
    resize_load(  xv_get(hbar, SCROLLBAR_VIEW_START), 
		  xv_get(vbar, SCROLLBAR_VIEW_START));
} 

/*
 * Notify callback function for `undo user point'.
 */
void
undo_user_point(item, event)
    Panel_item      item;
    Event           *event;
{
    int temp;
    temp = insert_p;
    insert_p = 0;
    add_usr_point(last_x,last_y);
    set_message7("last point deleted");
    insert_p = temp;
}

/* Notify callback function for `restore work'.
 */
void
restore_handler(item, event)
    Panel_item      item;
    Event           *event;
{
    int i, answer, temp;
    char  *c;
    char            buf[MAXPATHLEN];
    fputs("nxscan: restore_handler\n", stderr);
    if( !Pr_c ) { set_message7("load image first, then restore"); return; }
 
    sprintf(buf, "Warning! this overwrites any work");
    answer = notice_prompt(Nxscan->win, event,
			   NOTICE_MESSAGE_STRINGS, buf, 0,
			   NOTICE_BUTTON_YES, "Continue",
			   NOTICE_BUTTON_NO,  "stop",
			   0);
    if (answer == NOTICE_NO)
	return;
    if ((dumpfp = fopen(dumpfile, "r")) == NULL )
    {
	Event           event;
	char            buf[MAXPATHLEN];
 
	sprintf(buf, "Error in restore mechanism %s.", dumpfile);
	notice_prompt(Nxscan->win, &event,
		      NOTICE_MESSAGE_STRINGS, buf, 0,
		      NOTICE_BUTTON_YES, "Continue",
		      0);
	(void) fclose(dumpfp);
	return ;
    }
 
    c = (char *) &user_n;
    for(i = 0; i < sizeof(user_n); i++) 
	*(c+i) = fgetc(dumpfp);
    sprintf(buf, "restoring %d user points",user_n);
    set_message7(buf);
    c = (char *) user_p;
    for(i = 0; i < sizeof(user_p); i++)
	*(c+i) = fgetc(dumpfp);
    c = (char *) user_cf;
    for(i = 0; i < sizeof(user_cf); i++)
	*(c+i) = fgetc(dumpfp);
    c = (char *) &erase_n;
    for(i = 0; i < sizeof(erase_n); i++)
	*(c+i) = fgetc(dumpfp);
    sprintf(buf, "restoring %d erase points",erase_n);
    set_message7(buf);
    c = (char *) erase_p;
    for(i = 0; i < sizeof(erase_p); i++)
	*(c+i) = fgetc(dumpfp);
    c = (char *) erase_a;
    for(i = 0; i < sizeof(erase_a); i++)
	*(c+i) = fgetc(dumpfp);
    fclose(dumpfp);
    temp = erase_n;  	/* note this use of temp is necessary to avoid recurrsion */
    for( i=0; i < temp ; i++) {
	canvas_dat.addf= erase_a[i];
	erase( erase_p[i].x/canvas_dat.reduction, erase_p[i].y/canvas_dat.reduction, 1 );
    } 
    canvas_dat.addf = 0;
}

error_dump()
{
    int i;
    char *c;
    if ((dumpfp = fopen(dumpfile, "w")) == NULL )
    {
	Event           event;
	char            buf[MAXPATHLEN];

	sprintf(buf, "Error in error_dump mechanism %s.", dumpfile);
	notice_prompt(Nxscan->win, &event,
		      NOTICE_MESSAGE_STRINGS, buf, 0,
		      NOTICE_BUTTON_YES, "Continue",
		      0);
	(void) fclose(dumpfp);
	return ;
    }

    c = (char *) &user_n;
    for(i = 0; i < sizeof(user_n); i++)
	fputc(*(c+i),dumpfp);
    c = (char *) user_p;
    for(i = 0; i < sizeof(user_p); i++)
	fputc(*(c+i),dumpfp);
    c = (char *) user_cf;
    for(i = 0; i < sizeof(user_cf); i++)
	fputc(*(c+i),dumpfp);
    c = (char *) &erase_n;
    for(i = 0; i < sizeof(erase_n); i++)
	fputc(*(c+i),dumpfp);
    c = (char *) erase_p;
    for(i = 0; i < sizeof(erase_p); i++)
	fputc(*(c+i),dumpfp);
    c = (char *) erase_a;
    for(i = 0; i < sizeof(erase_a); i++)
	fputc(*(c+i),dumpfp);
    fclose(dumpfp);
}


/*
 * Notify callback function for `selection_s_popup'.
 */
void
select_s_callback(item, value, event)
    Panel_item	item;
    int		value;
    Event		*event;
{
    /* fprintf(stderr, "nxscan: select_s_callback: value: %u\n", value); */
    save_format = value;
    switch(value) {
    case 0:
	xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,
	       "saving user points", NULL);
	xv_set(Save_choser->popup, XV_SHOW, TRUE, NULL);
	break;
    case 1:
	xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,
	       "saving raw digitized points", NULL);
	xv_set(Save_choser->popup, XV_SHOW, TRUE, NULL);
	break;
    case 2:
	xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,
	       "saving into SAC format", NULL);
	xv_set(Save_SAC->popup, XV_SHOW, TRUE, NULL);
	break;
    case 3:
	xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,
	       "saving into unimplemented format, not saved!", NULL);
	break;
    default:
	fputs("nXscan: error in selection mechanism, save popup\n", stderr);
	break;
    }
}

/*
 * Load a raster file.
 */
int
nxscan_file_load(file)
    char           *file;
{
    FILE           *fp;
    colormap_t      colormap;
    char           *p,*period,*cbuf;
#ifdef	SUNOS
    struct mpr_data     *pt;
#else
    struct raster     *pt;
#endif
    int             i,j,temp,temph;
 
    /*
     * Open file.
     */
    nxscan_file_close();
    if( (period=rindex(file,'.')) == NULL )
    {
	Event           event;
	char            buf[MAXPATHLEN];
 
	sprintf(buf, "Size heirarchy not found, %s", file);
	notice_prompt(Nxscan->win, &event,
		      NOTICE_MESSAGE_STRINGS, buf, 0,
		      NOTICE_BUTTON_YES, "Continue",
		      0);
	return ;
    }
    *(period+1) = 'H';
    *(period+2) = '\0';
    if ((fp = fopen(file, "r")) == NULL )
    {
	Event           event;
	char            buf[MAXPATHLEN];
 
	sprintf(buf, "Cannot load %s", file);
	notice_prompt(Nxscan->win, &event,
		      NOTICE_MESSAGE_STRINGS, buf, 0,
		      NOTICE_BUTTON_YES, "Continue",
		      0);
	(void) fclose(fp);
	return ;
    }
    /* read .H file for size, calculate best view */
    xv_set(Nxscan->win, FRAME_RIGHT_FOOTER, canvas_dat.file , 0);
    cbuf = (char *) &image_dat;
    for(j=0; j < sizeof(image_dat); cbuf[j++] = getc(fp) );
    (void) fclose(fp);
    j =  (int) atoi ((char *)xv_get(Load_choser->dpi, PANEL_VALUE));
    if ( j > 0 ) image_dat.xresolution = j;
    fprintf(stderr, "image res dpi%d\n",image_dat.xresolution);
    sprintf(message2dpi,"%d dpi",image_dat.xresolution);
    xv_set(Nxscan->message2,PANEL_LABEL_STRING,message2dpi,NULL);

/* dump file prep. */
    *(period+1) = 'D';
    dumpfp = NULL;
    strcpy(dumpfile,file);

    *(period+1) = '0';
    for(j=0;   (fp = fopen(file, "r")) != NULL ; *(period+1) = '0' + ++j ) {
	fprintf(stderr," loading file number %d\n",j);
	if ( (Pr[j] = pr_load(fp, &colormap)) == NULL 
	     || Pr[j]->pr_depth != 1) {
	    Event           event;
	    char            buf[MAXPATHLEN];
      
	    sprintf(buf, "Cannot load %s, not enough memory", file);
	    notice_prompt(Nxscan->win, &event,
			  NOTICE_MESSAGE_STRINGS, buf, 0,
			  NOTICE_BUTTON_YES, "Continue",
			  0);
	    (void) fclose(fp);
	}
	else { (void) fclose(fp);
#ifdef SUNOS
	pt = (struct mpr_data *) Pr[j]->pr_data;
	xim[j]=XCreateImage(dpy,&dvisual,1,XYBitmap,0,(char *) (pt->md_image),
			    Pr[j]->pr_size.x,Pr[j]->pr_size.y,16,
			    pt->md_linebytes);
#else
	pt = (struct raster *) Pr[j]->pr_data;
	xim[j]=XCreateImage(dpy,&dvisual,1,XYBitmap,0,(char *) (pt->pixels),
			    Pr[j]->pr_size.x,Pr[j]->pr_size.y,8*sizeof(long),
			    pt->linelongs*sizeof(long));
#endif
	}
    }
    if ( j == 0 ) {
	Event           event;
	char            buf[MAXPATHLEN];
	sprintf(buf, "WARNING, No Files Loaded!");
	notice_prompt(Nxscan->win, &event,
		      NOTICE_MESSAGE_STRINGS, buf, 0,
		      NOTICE_BUTTON_YES, "Continue",
		      0);
	return ;
    }
    i=0;
    for( j=0; j <= 9 ; j++ )  if ( Pr[j] != NULL ) i++ ; 
    fprintf(stderr," number of files loaded %d\n",i);
 
    for( j=0; Pr[j] == NULL; j++) ;
    canvas_dat.maxpix = j;	/* set the pix number of max size loaded pix (should be 0 ) */

    canvas_dat.win_w = (int) xv_get(hbar, SCROLLBAR_VIEW_LENGTH);
    canvas_dat.win_h = (int) xv_get(vbar, SCROLLBAR_VIEW_LENGTH);
    locate_dat.win_w = (int) xv_get(Nxscan_locate_popup->locate_canvas,XV_WIDTH);
    locate_dat.win_h = (int) xv_get(Nxscan_locate_popup->locate_canvas,XV_HEIGHT);

    /* find one that is just bigger than screen */
    temp = image_dat.width;
    for(j=0; (temp/=2) > canvas_dat.win_w; j++);
    if( j > 9 ) j=9;
    canvas_dat.pix =j;
    if ( (Pr_c = Pr[j]) == NULL ) fputs("fatal error, no Image??",stderr); 
	
    if( tr != NULL )  free( tr );
    if( (tr = (XPoint *)  malloc( xim[canvas_dat.maxpix]->width * sizeof(XPoint) ) ) == NULL)
	fprintf(stderr,"Malloc returned an error!!\n");
    if( tr2 != NULL )  free( tr2 );
    if( (tr2 = (XPoint *) malloc( xim[canvas_dat.maxpix]->width * sizeof(XPoint) ) ) == NULL)
	fprintf(stderr,"Malloc returned an error!!\n");

    resize_load(0,0);
 
    temp = image_dat.width; temph = image_dat.height;
    for(j=0; (temp/=2) > locate_dat.win_w; j++) temph/=2;
    for(; (temph/=2) > locate_dat.win_h; j++) ;
    if( j > 8 ) { j=8; puts("Warning, pixrect too large to use locator popup!"); }
    locate_dat.pix = j+1;
    Pr_l = Pr[j+1];  

    locate_dat.loc_to_main_ratio = 1;
    for( i = 0; i++ < ( j+1 - canvas_dat.pix); 
	 locate_dat.loc_to_main_ratio *= 2);
    fprintf(stderr,"locate_ratio %d\n",locate_dat.loc_to_main_ratio);
/* load pix2 */
 

    xv_set(Nxscan->message2,PANEL_LABEL_STRING,message2dpi,NULL);
    xv_set(Nxscan->message4,PANEL_LABEL_STRING,message4loc,NULL);
    xv_set(Nxscan->message6,PANEL_LABEL_STRING,message6loc,NULL);
 
    xv_set(Nxscan_locate_popup->locate_canvas, 
	   CANVAS_WIDTH, Pr_l->pr_size.x, CANVAS_HEIGHT, Pr_l->pr_size.y, 0);
    locate_dat.canvas_w = Pr_l->pr_size.x;
    locate_dat.canvas_h = Pr_l->pr_size.y;

#ifdef SUNOS
    pt = (struct mpr_data *) Pr_l->pr_data;
    xim2=XCreateImage(dpy,&dvisual,1,XYBitmap,0,
		      (char *) (pt->md_image), Pr_l->pr_size.x,
		      Pr_l->pr_size.y,16 ,pt->md_linebytes);
#else
    pt = (struct raster *) Pr_l->pr_data;
    xim2=XCreateImage(dpy,&dvisual,1,XYBitmap,0,
		      (char *) (pt->pixels), Pr_l->pr_size.x,
		      Pr_l->pr_size.y, 8*sizeof(long), pt->linelongs*sizeof(long));
#endif
    XPutImage(dpy,xid_locate,gc_solid,xim2,0,0,0,0,
	      Pr_l->pr_size.x,Pr_l->pr_size.y);

    locate_dat.box_size_x = 
	canvas_dat.win_w /(2*locate_dat.loc_to_main_ratio);
    locate_dat.box_size_y = 
	canvas_dat.win_h /(2*locate_dat.loc_to_main_ratio);
    locate_dat.new_box_x = locate_dat.box_size_x;
    locate_dat.new_box_y = locate_dat.box_size_y;
    locate_dat.old_box_x = locate_dat.box_size_x;
    locate_dat.old_box_y = locate_dat.box_size_y;
    if ( locate_dat.box_exposed == 0 ) {
	locate_dat.box_exposed = 1;
	drawbox( dpy, xid_locate , gc_dashed , locate_dat.new_box_x, 
		 locate_dat.new_box_y,2*locate_dat.box_size_x,
		 2*locate_dat.box_size_y);  
    } 
 
    return ;
}
 
/*
Save a rasterfile
*/
int
nxscan_file_save(file)
    char            *file;
{
    FILE           *fp;
    char   *j, buf[MAXPATHLEN +20];
    float datay,datax,slopeorg,slopeloc,b_org;
    int x1,x2,y1,y2;
    int i,k;
 
    /*
     * Open file.
     */
    if( save_format == 0 ) {
 	if ((fp = fopen(file, "w")) == NULL )
	{
	    Event           event;
	    char            buf[MAXPATHLEN];
 
	    sprintf(buf, "Cannot save %s.", file);
	    notice_prompt(Nxscan->win, &event,
			  NOTICE_MESSAGE_STRINGS, buf, 0,
			  NOTICE_BUTTON_YES, "Continue",
			  0);
	    (void) fclose(fp);
	    return ;
	} 
        else {
	    sprintf(buf, "user points saved into file: %s", file);
	    /* save digitized list */
 
	    for( i = 0; i<user_n; i++)
		fprintf(fp,"%d %d\n",(int) ((user_p+i)->x),(int) ((user_p+i)->y) );
 
	    (void) fclose(fp);
	    xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,buf, NULL);
	    fprintf(stderr,"file saved succesfully\n");
	}
        return ;
    }

    else if( save_format == 1 ) {
        if ((fp = fopen(file, "w")) == NULL )
	{
	    Event           event;
	    char            buf[MAXPATHLEN];
 
	    sprintf(buf, "Cannot save %s.", file);
	    notice_prompt(Nxscan->win, &event,
			  NOTICE_MESSAGE_STRINGS, buf, 0,
			  NOTICE_BUTTON_YES, "Continue",
			  0);
	    (void) fclose(fp);
	    return ;
	} 
	else {
	    sprintf(buf, "digitization saved into file: %s", file);
	    /* save digitized list */

	    for( i = 0; i<tr_n; i++)
		fprintf(fp,"%d %d\n",(int) ((tr+i)->x),(int) ((tr+i)->y) );

	    (void) fclose(fp);
	    xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,buf, NULL);
	    fprintf(stderr,"file saved succesfully\n");
	}
        return ;
    }
    else if( save_format > 1 ) {
	sprintf(buf, "SAC format in progress");
	xv_set(Nxscan_save_popup->save_message_popup,PANEL_LABEL_STRING,buf, NULL);
	if ((fp = fopen(file, "w")) == NULL )
	{
	    Event           event;
	    char            buf[MAXPATHLEN];
	 
	    sprintf(buf, "Cannot save %s.", file);
	    notice_prompt(Nxscan->win, &event,
			  NOTICE_MESSAGE_STRINGS, buf, 0,
			  NOTICE_BUTTON_YES, "Continue",
			  0);
	    (void) fclose(fp);
	    return ;
	}
	else {
	    sprintf(buf, "SAC digitization saved into file: %s", file);
	    xv_set(Nxscan_save_popup->save_message_popup,
		   PANEL_LABEL_STRING,buf, NULL);
	    /*write header then data */
	    j = (char *) &SAC_head.delta;
	    for( i = 0; i < SACHEADERSIZE; i++) putc( *(j+i) , fp);
	    /* save digitized list */
	    /* calc neutral baseline equation */
/* remember y is positive down! therfore here ALL y is considered negative! */

	    slopeorg = (float)(baseliney1-baseliney2)/
		((float)(baselinex2-baselinex1));
	    b_org = -baseliney1 - slopeorg*baselinex1;
/*
  printf("basx basy basx2 basy2 %d %d %d %d\n",baselinex1,baseliney1,baselinex2,baseliney2);
  printf("slope b %f %f \n",slopeorg,b_org);
  */
			
	    k=1;
	    for( i = 0; i < SAC_head.npts ; i++) {
		datax = i*SAC_head.delta*pixpersec;
		/* datax is pix+frac from data start */
		while( (x2 = (int) ( (tr+k)->x - tr->x ) ) < datax ) {
		    k++;
		    if( k > tr_n ) printf("k larger than tr_n\n"); 
		}

		x1 = (int) ( (tr+k-1)->x - tr->x );
		y1 = -(int) (tr+k-1)->y;
		y2 = -(int) (tr+k)->y;
		datay =  y1 + (datax - x1) * ( y2 - y1 ) ;

		datay = datay - (datax+tr->x)*slopeorg - b_org;
		datay = datay * MMPERINCH/image_dat.xresolution;
		fwrite( &datay, sizeof(float), 1, fp);
/*
  printf("k %d, i %d, datax %f datay %f\n      tr->x %d tr->y %d",k,i,datax,datay,(tr+k)->x,(tr+k)->y);
  printf("datax - trx %f\n", (datax - (int) (tr+k-1)->x));
  */

	    }	
	    fprintf(stderr,"file saved succesfully, %d points output\n",i);
	    (void) fclose(fp);
	    if(oldtimeflag != 0) {
		XDrawLine(dpy,xid,gc_dashed,oldtimelinex,
			  oldtimeliney-50,oldtimelinex,
			  oldtimeliney+50);
		XDrawLine(dpy,xid,gc_dashed,oldtimelinex-50,
			  oldtimeliney,oldtimelinex+50,
			  oldtimeliney);
	    }	
	    oldtimeflag = 0;

	}
	return ; 
    }
}
 

Notify_value
ndestroy_func(client,status)
    Notify_client client;
    Destroy_status status;
{
    if (status == DESTROY_CHECKING) {
	int answer = notice_prompt(client,NULL,
				   NOTICE_MESSAGE_STRINGS, "Do you really want to QUIT?", NULL,
				   NOTICE_BUTTON_YES, "No",
				   NOTICE_BUTTON_NO,  "Yes",
				   NULL);
	if (answer == NOTICE_YES)
	    notify_veto_destroy(client);
    }
    else    if (status == DESTROY_CLEANUP) {
	puts("Cleaning-up");
	return notify_next_destroy_func(client,status);
    }
    else    if (status == DESTROY_SAVE_YOURSELF)
	puts("How am I supposed to save myself?");
    else    puts("process dies");
 
    return NOTIFY_DONE;
}

int
quit(obj)
    Xv_opaque obj;
{
    xv_destroy_safe(obj);
    return XV_OK;
}

/*
 * Repaint callback function for `canvas'.
 */
/*ARGSUSED*/
void
canvas_repaint(canvas, paint_window, display, xwin, rects)
    Canvas          canvas;
    Xv_window       paint_window;
    Display         *display;
    Window          xwin;
    Xv_xrectlist    *rects;
{
    /* fputs("nxscan: canvas_repaint\n", stderr); */

    if (!Pr_c ) return;

    XPutImage(display,xwin,gc_solid,xim[canvas_dat.pix],0,0,0,0,Pr_c->pr_size.x,Pr_c->pr_size.y);
    line_on = 0;
}


void
locate_canvas_repaint(canvas, paint_window, display, xwin, rects)
    Canvas          canvas;
    Xv_window       paint_window;
    Display         *display;
    Window          xwin;
    Xv_xrectlist    *rects;
{
    /* fputs("locate_popoup: canvas_repaint\n", stderr); */
    if (!Pr_c ) return;

    XPutImage(display,xwin, gc_solid,xim2,0,0,0,0,Pr_l->pr_size.x,Pr_l->pr_size.y);
    locate_dat.box_exposed = 1;
    drawbox( display, xwin , gc_dashed , 
	     locate_dat.old_box_x,locate_dat.old_box_y,
	     2*locate_dat.box_size_x,2*locate_dat.box_size_y); 
}


void
canvas1_repaint(canvas, paint_window, display, xwin, rects)
    Canvas		canvas;
    Xv_window	paint_window;
    Display		*display;
    Window		xwin;
    Xv_xrectlist	*rects;
{
    /* fputs("nxscan: canvas1_repaint\n", stderr); */
    if (!Pr_c ) return;
/* this ia a wasteful method, but simple */
    resize_load(  xv_get(hbar, SCROLLBAR_VIEW_START), 
		  xv_get(vbar, SCROLLBAR_VIEW_START));
}


/*
 * Close a raster file.
 */
void
nxscan_file_close()
{
    if (!Pr_c )
	return;
    XClearWindow(dpy,xid);
    XClearWindow(dpy,xid_locate);
    locate_dat.box_exposed = 0;
/* clear locate_dat struct and canvas_dat struct */
    pr_destroy(Pr_c);    /*  ZZZZZ */
    Pr_c = NULL;
    (void) fclose(dumpfp);
 
    xv_set(Nxscan->win, FRAME_RIGHT_FOOTER, "", 0);
}

/* invert black (or could be color) for white */
invert_color()
{
    Event           event;
    char            buf[MAXPATHLEN];
 
    sprintf(buf, "Use filter \"invert_pix\" on input");
    notice_prompt(Nxscan->win, &event,
		  NOTICE_MESSAGE_STRINGS, buf, 0,
		  NOTICE_BUTTON_YES, "Continue",
		  0);
}
 
/*
 * Notify callback function for `invert_pixels'.
 */
void
invert_display_handler(item, event)
    Panel_item      item;
    Event           *event;
{
    invert_color();
}

/*
 * Resize callback function for `locate_canvas'.
 */
void
loc_resize(canvas, width, height)
    Canvas          canvas;
    int             width;
    int             height;
{
    if( !Pr_c ) return;
    locate_dat.win_w = (int) xv_get(canvas,XV_WIDTH);
    locate_dat.win_h = (int) xv_get(canvas,XV_HEIGHT);
    /* fputs("nxscan: resize in locate popup\n", stderr); */
}

/*
 * Resize callback function for `main canvas'.
 */
void
canvas_resize(cv, width, height)
    Canvas          cv;
    int             width;
    int             height;
{
    if( !Pr_c ) return;
    canvas_dat.win_w = (int) xv_get(hbar, SCROLLBAR_VIEW_LENGTH);
    canvas_dat.win_h = (int) xv_get(vbar, SCROLLBAR_VIEW_LENGTH);
    /*   fputs("nxscan: resize in main canvas\n", stderr);  */
}

resize_load(x,y)
    int x,y;
{
    int w,h,i,max,temp;
    char c[6];
    set_message7("loading resize pix");
    oldtimeflag = 0;   /* SAC header popup stuff */
    erase_mem(0);
    temp = 1;
    for( i=0; i != canvas_dat.maxpix; i++) temp *= 2;
    canvas_dat.res = image_dat.xresolution/temp;   /* temp is part of too large pix KLUDGE */
    canvas_dat.reduction = 1;
    for(; i++ < canvas_dat.pix; canvas_dat.res /= 2) canvas_dat.reduction *= 2;
    /* note i above is subtle */
    sprintf(message5dpi,"%d dpi",canvas_dat.res);
    xv_set(Nxscan->message5,PANEL_LABEL_STRING, message5dpi,NULL);

/* * Reset canvas width/height and scrollbars.  */
    xv_set(Nxscan->canvas,
	   CANVAS_WIDTH, Pr_c->pr_size.x,
	   CANVAS_HEIGHT, Pr_c->pr_size.y,
	   0);
    xv_set(hbar, SCROLLBAR_VIEW_START, x, 0);
    xv_set(vbar, SCROLLBAR_VIEW_START, y, 0);
    XClearWindow(dpy,xid);
    XPutImage(dpy,xid,gc_solid,xim[canvas_dat.pix],0,0,0,0,Pr_c->pr_size.x,Pr_c->pr_size.y);
    canvas_dat.canvas_w  = (int)       xv_get(Nxscan->canvas, CANVAS_WIDTH );
    canvas_dat.canvas_h =  (int)       xv_get(Nxscan->canvas , CANVAS_HEIGHT );
/* add user_list and trace handling here */
    if( line_on == 1) notify_flash_line();

/* put a scale in canvas1 */
    XClearWindow(dpy,xid1);
    XDrawString(dpy,xid1,gc_dashed,20,42,"scale in inches, relative to original",37);
    max = (int) xv_get(Nxscan->canvas1,XV_WIDTH);
    XDrawLine(dpy,xid1,gc_dashed,20,30,max-20,30);
    for( w=20, i=0; w < max-canvas_dat.res ; i++,  w += canvas_dat.res) { 
	sprintf(c,"%-d",i);
	XDrawLine(dpy,xid1,gc_dashed,w,18,w,30);
	XDrawLine(dpy,xid1,gc_dashed,w+canvas_dat.res/2,22,w+canvas_dat.res/2,30);
	XDrawLine(dpy,xid1,gc_dashed,w+canvas_dat.res/4,25,w+canvas_dat.res/4,30);
	XDrawLine(dpy,xid1,gc_dashed,w+3*canvas_dat.res/4,
		  25,w+3*canvas_dat.res/4,30);
	if( i < 10 ) XDrawString(dpy,xid1,gc_dashed,w-2,15,c,1);
	else XDrawString(dpy,xid1,gc_dashed,w-2,15,c,2);
    }
    sprintf(c,"%-d",i);
    XDrawLine(dpy,xid1,gc_dashed,w,18,w,30);
    XDrawString(dpy,xid1,gc_dashed,w-2,15,c,1);
    XDrawString(dpy,xid1,gc_dashed,16+canvas_dat.res/2,15,"0.5",3);
	
}

set_message7(s)
    char *s;
{
    xv_set(Nxscan->message7,PANEL_LABEL_STRING,s,NULL);
}

erase(x,y,restore_flag) /* x,y is in the current image coord system */
    int x,y , restore_flag;
{
    int i,j,k,square,ta;
    unsigned long   px;
    if( erase_dat.pending != 0 ) erase_mem(restore_flag);
    ta = canvas_dat.addf/canvas_dat.reduction;    /* reduce size to screen image */
    if ( ta < 0 ) ta *= -1;

    if( canvas_dat.addf < 0 ) {
	/* fprintf(stderr,"erase function called\n"); */
	XFillRectangle(dpy,xid,gc_solid,x-ta/2,y-ta/2, ta,ta); 
	/* XFillArc(dpy,xid,gc_solid,x-ta/2,y-ta/2, ta,ta,0,23040); */
	px = BlackPixel(dpy,dscreen_n);
    }
    else    {
	/* fprintf(stderr,"add function called\n"); */
	XFillRectangle(dpy,xid,gc_invert,x-ta/2,y-ta/2, ta,ta);
	/* XFillArc(dpy,xid,gc_invert,x-ta/2,y-ta/2, ta,ta,0,23040); */
	px = WhitePixel(dpy,dscreen_n);
    }
    x *= canvas_dat.reduction;
    y *= canvas_dat.reduction;
    erase_dat.x = x; erase_dat.y = y;
    erase_dat.px = px;
    erase_dat.addf = canvas_dat.addf;
    erase_dat.pending = 1;
}

erase_mem(r_flag)
    int r_flag;
{
    int i,j,k,halfsquare,tx,ty,ta, l,it,jt;
    if( erase_dat.pending == 0 ) return;
    if( r_flag == 0 ) {
	erase_p[erase_n].x = erase_dat.x; erase_p[erase_n].y = erase_dat.y;
	erase_a[erase_n] = erase_dat.addf;
	erase_n += 1;   		/* make list of erase points */
    }
    erase_dat.square = erase_dat.addf;
    if( erase_dat.square < 0 ) erase_dat.square *= -1;
    for(k=canvas_dat.maxpix; Pr[k] != NULL; k++){
	halfsquare = erase_dat.square/2 ;  /* find offset to senter of area */
	tx = erase_dat.x - halfsquare;
	ty = erase_dat.y - halfsquare;
	jt = erase_dat.square;
	it = erase_dat.square;
	for (j = ty; j < ty+jt; j++)
	    for (i = tx; i < tx+it; i++) {
		if( i < 0 || j < 0 || i > Pr[k]->pr_size.x ||
                    j > Pr[k]->pr_size.y ) { puts("erase out of bounds"); return;}
		XPutPixel(xim[k],i,j, erase_dat.px );
	    }

/*  this is a section which draws an octagon (1st loop works?) 
    for (l = 0, j = ty; j < (ty + jt/8); j++ , l+= 2) 
    for( i = tx + (3*it)/8 - l) ; i < (i < (tx + l + (5*it)/8)); i++)
    XPutPixel(xim[k],i,j, erase_dat.px );
    for (l = 0, j = ty + jt/8;  j < (ty + (3*jt)/8); j++)
    for(l = 0, i = tx + (it)/8 - l; i < (tx + l + (7*it)/8); i++, l = l + i%2)
    XPutPixel(xim[k],i,j, erase_dat.px ); */


	erase_dat.x /= 2;
	erase_dat.y /= 2;
	if( (erase_dat.square /= 2) < 1 ) break;
    }
    erase_dat.pending = 0;
}

/*
 * Notify callback function for `clear_all_points_but'.
 */
void
clear_all_points(item, event)
    Panel_item      item;
    Event           *event;
{
    fputs("nxscan: clear_all_points\n", stderr);
    if ( line_on == 1) notify_flash_line();     /* erase line if already drawn */
    user_n = 0;
    tr_n   = 0;
}

show_userlist()
{
    int i,tx,ty;
    for(i=0; i<user_n; i++) {
	tx = (int) (user_p[i].x/canvas_dat.reduction);
	ty = (int) (user_p[i].y/canvas_dat.reduction);
	if( user_cf[i] == 1 ) {
	    XDrawLine(dpy,xid,gc_dashed,tx -3,
		      ty -3,
		      tx +3,
		      ty +3);
	    XDrawLine(dpy,xid,gc_dashed,tx +3,
		      ty -3,
		      tx -3,
		      ty +3);
	}
	else {
	    drawbox(dpy,xid,gc_dashed,tx,
		    ty,5,5); }
	if(i > 0)
	    XDrawLine(dpy,xid,gc_dashed,(int) (user_p[i-1].x/canvas_dat.reduction),
		      (int) (user_p[i-1].y/canvas_dat.reduction),tx,ty);
    }
    line_on = (line_on + 1) %2; 
}
 
show_trace()
{
    int i;
    if( tr_n > 0) XDrawPoint(dpy,xid,gc_dashed,(int) (tr[0].x/canvas_dat.reduction),
			     (int) (tr[0].y/canvas_dat.reduction) );
    for(i=1; i < tr_n; i++) {
	XDrawPoint(dpy,xid,gc_dashed,(int) (tr[i].x/canvas_dat.reduction),
		   (int) (tr[i].y/canvas_dat.reduction) ); 
	XDrawLine(dpy,xid,gc_dashed,(int) (tr[i-1].x/canvas_dat.reduction),
		  (int) (tr[i-1].y/canvas_dat.reduction),
		  (int) (tr[i].x/canvas_dat.reduction),
		  (int) (tr[i].y/canvas_dat.reduction));
    }
    line_on = (line_on + 1) %2; 
}
 
add_usr_point(x,y)
    int x,y;
{
    last_x = x; last_y = y;
    if ( line_on == 1) notify_flash_line();     /* erase line if already drawn */
    if( insert_p == 2 ) user_cf[user_n] = 1;
    else user_cf[user_n] = 0;
    user_p[user_n].x = x * canvas_dat.reduction;
    user_p[user_n++].y = y * canvas_dat.reduction;
    if(insert_p != 0) insert(x * canvas_dat.reduction,y * canvas_dat.reduction);
    else             delete(x * canvas_dat.reduction,y * canvas_dat.reduction);
}

insert(x,y)
    int x,y;
{
    int j,i=0;
    while(user_p[i].x < x) i++;
    for(j= (user_n-1); j>i; j--) {
	user_p[j].x = user_p[j-1].x;
	user_p[j].y = user_p[j-1].y;
	user_cf[j]  = user_cf[j-1] ;
    }
    user_p[i].x=x;
    user_p[i].y=y;
    if( insert_p == 2 ) user_cf[i] = 1;
    else user_cf[i] = 0;
}
 
delete(x,y)
    int x,y;
{
    int i=0;
    while(user_p[i].x < (x-2) ) i++;
    if( user_p[i].x < (x+2) ){
	for( ; i < (user_n-1); i++) {
	    user_p[i].x = user_p[i+1].x;
	    user_p[i].y = user_p[i+1].y;
	    user_cf[i]  = user_cf[i+1] ;
	}
	user_n--;
    }  
    user_n--;
}


/*
 * Notify callback function for `pen_arc_but'.
 */
void
pen_arc_handler(item, event)
    Panel_item      item;
    Event           *event;
{
    fputs("nxscan: pen arc correction, not yet installed in current version\n", stderr);
}

void
SAC_time_start(){ timeflag = 1;}

void
SAC_time_stop() { timeflag = 2;}

void
SAC_nz_start() { timeflag = 3;}

void
SAC_y_start() { timeflag = 4;}

void
SAC_y_stop() { timeflag = 5;}

void
SAC_compute()
{
    double atof();
    char b[70], *strcpy();
    float pix_dif,time_dif;
    if( timepoint[0] < 0 ) return;
    if( timepoint[1] < 0 ) return;
    SAC_head.iftype = 1;
    SAC_head.leven = 1;
    strcpy (SAC_head.kstnm, (char *)  xv_get(Save_SAC->kstnm, PANEL_VALUE));
    SAC_head.b =  (float) atof (xv_get(Save_SAC->B, PANEL_VALUE));
    SAC_head.delta =  (double) atof (xv_get(Save_SAC->delta, PANEL_VALUE));
    SAC_head.nzyear =  (long) atoi ((char *)xv_get(Save_SAC->nzyear, PANEL_VALUE));
    SAC_head.nzjday =  (long) atoi ((char *)xv_get(Save_SAC->nzday, PANEL_VALUE));
    SAC_head.nzhour =  (long) atoi ((char *)xv_get(Save_SAC->nzhour, PANEL_VALUE));
    SAC_head.nzmin =  (long) atoi ((char *)xv_get(Save_SAC->nzmin, PANEL_VALUE));
    SAC_head.nzsec =  (long) atoi ((char *)xv_get(Save_SAC->nzsec, PANEL_VALUE));
    SAC_head.nzmsec =  (long) atoi ((char *)xv_get(Save_SAC->nzmsec, PANEL_VALUE));
    pix_dif  =  (float) atoi ((char *)xv_get(Save_SAC->pix_dif, PANEL_VALUE));  
    sprintf(b,"%s", (char *)  xv_get(Save_SAC->time_dif, PANEL_VALUE) ); 

    time_dif =  (float) atof ( b ); 
    if( time_dif > 0.)
	pixpersec = pix_dif/time_dif;
    if(timepoint[2] > 0 )  SAC_head.b = (tr->x - timepoint[2])/pixpersec;

    SAC_head.e = SAC_head.b + (tr_n-1) / pixpersec;
    if( SAC_head.delta > 0. )
	SAC_head.npts = (long) ( (SAC_head.e - SAC_head.b)/SAC_head.delta + 1);
    sprintf(b,"%f",SAC_head.e);
    xv_set(Save_SAC->E, PANEL_VALUE, b, 0);
    sprintf(b,"%f",SAC_head.b);
    xv_set(Save_SAC->B, PANEL_VALUE, b, 0);
    sprintf(b,"%ld",SAC_head.npts);
    xv_set(Save_SAC->npts, PANEL_VALUE, b, 0);
    SAC_head.internal4 = SACVERSION;
}
