
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include "gcm.h"
#include "nxscan_ui.h"

/*
 * Create object `file_menu' in the specified instance.
 */
Xv_opaque
nxscan_file_menu_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern Menu_item	nxscan_load_handler();
	extern Menu_item	file_save_callback();
	extern Menu_item	exit_handler();
	Xv_opaque	obj;
	
	obj = xv_create(XV_NULL, MENU_COMMAND_MENU,
		XV_KEY_DATA, INSTANCE, ip,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Load...",
			MENU_GEN_PROC, nxscan_load_handler,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Save...",
			MENU_GEN_PROC, file_save_callback,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Quit",
			MENU_GEN_PROC, exit_handler,
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `magnify_menu' in the specified instance.
 */
Xv_opaque
nxscan_magnify_menu_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern Menu_item	mag_handler();
	extern Menu_item	reduce_handler();
	extern Menu_item	redraw_handler();
	Xv_opaque	obj;
	
	obj = xv_create(XV_NULL, MENU_COMMAND_MENU,
		XV_KEY_DATA, INSTANCE, ip,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Magnify",
			MENU_GEN_PROC, mag_handler,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Reduce",
			MENU_GEN_PROC, reduce_handler,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Redraw",
			MENU_GEN_PROC, redraw_handler,
			NULL,
		MENU_GEN_PIN_WINDOW, owner, "",
		NULL);
	return obj;
}

/*
 * Create object `options_menu' in the specified instance.
 */
Xv_opaque
nxscan_options_menu_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern Menu_item	nxscan_options_menu_item0_callback();
	extern Menu_item	nxscan_options_menu_item1_callback();
	extern Menu_item	nxscan_options_menu_item2_callback();
	Xv_opaque	obj;
	
	obj = xv_create(XV_NULL, MENU_COMMAND_MENU,
		XV_KEY_DATA, INSTANCE, ip,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Locator Pop-up",
			MENU_GEN_PROC, nxscan_options_menu_item0_callback,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Tools Pop-up",
			MENU_GEN_PROC, nxscan_options_menu_item1_callback,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Unix Shell",
			MENU_GEN_PROC, nxscan_options_menu_item2_callback,
			NULL,
		MENU_GEN_PIN_WINDOW, owner, "",
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `win'.
 */
nxscan_win_objects *
nxscan_win_objects_initialize(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (nxscan_win_objects *) calloc(1, sizeof (nxscan_win_objects))))
		return (nxscan_win_objects *) NULL;
	if (!ip->win)
		ip->win = nxscan_win_win_create(ip, owner);
	if (!ip->controls)
		ip->controls = nxscan_win_controls_create(ip, ip->win);
	if (!ip->file_button)
		ip->file_button = nxscan_win_file_button_create(ip, ip->controls);
	if (!ip->mag_button)
		ip->mag_button = nxscan_win_mag_button_create(ip, ip->controls);
	if (!ip->options_button)
		ip->options_button = nxscan_win_options_button_create(ip, ip->controls);
	if (!ip->message9)
		ip->message9 = nxscan_win_message9_create(ip, ip->controls);
	if (!ip->message8)
		ip->message8 = nxscan_win_message8_create(ip, ip->controls);
	if (!ip->message1)
		ip->message1 = nxscan_win_message1_create(ip, ip->controls);
	if (!ip->message5)
		ip->message5 = nxscan_win_message5_create(ip, ip->controls);
	if (!ip->message2)
		ip->message2 = nxscan_win_message2_create(ip, ip->controls);
	if (!ip->message3)
		ip->message3 = nxscan_win_message3_create(ip, ip->controls);
	if (!ip->message4)
		ip->message4 = nxscan_win_message4_create(ip, ip->controls);
	if (!ip->message6)
		ip->message6 = nxscan_win_message6_create(ip, ip->controls);
	if (!ip->message7)
		ip->message7 = nxscan_win_message7_create(ip, ip->controls);
	if (!ip->canvas1)
		ip->canvas1 = nxscan_win_canvas1_create(ip, ip->win);
	if (!ip->canvas)
		ip->canvas = nxscan_win_canvas_create(ip, ip->win);
	return ip;
}

/*
 * Create object `win' in the specified instance.
 */
Xv_opaque
nxscan_win_win_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	Xv_opaque		win_image;
	static unsigned short	win_bits[] = {
#include "images/lockscreen.icon"
	};
	
	win_image = xv_create(XV_NULL, SERVER_IMAGE,
		SERVER_IMAGE_DEPTH, 1,
		SERVER_IMAGE_BITS, win_bits,
		XV_WIDTH, 64,
		XV_HEIGHT, 64,
		NULL);
	obj = xv_create(owner, FRAME,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 862,
		XV_HEIGHT, 673,
		XV_LABEL, "NXScan V 8.1",
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_ICON, xv_create(XV_NULL, ICON,
			ICON_IMAGE, win_image,
			XV_LABEL, "NXScan",
			NULL),
		NULL);
	gcm_initialize_colors(obj, "Black", "White");
	return obj;
}

/*
 * Create object `controls' in the specified instance.
 */
Xv_opaque
nxscan_win_controls_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, 96,
		WIN_BORDER, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `file_button' in the specified instance.
 */
Xv_opaque
nxscan_win_file_button_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 8,
		PANEL_LABEL_STRING, "File",
		PANEL_ITEM_MENU, nxscan_file_menu_create((caddr_t) ip, ip->win),
		NULL);
	return obj;
}

/*
 * Create object `mag_button' in the specified instance.
 */
Xv_opaque
nxscan_win_mag_button_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	extern void		nxscan_win_mag_button_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 80,
		XV_Y, 8,
		PANEL_LABEL_STRING, "Resize",
		PANEL_ITEM_MENU, nxscan_magnify_menu_create((caddr_t) ip, ip->win),
		PANEL_NOTIFY_PROC, nxscan_win_mag_button_notify_callback,
		NULL);
	return obj;
}

/*
 * Create object `options_button' in the specified instance.
 */
Xv_opaque
nxscan_win_options_button_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	extern void		options_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 176,
		XV_Y, 8,
		PANEL_LABEL_STRING, "Options",
		PANEL_ITEM_MENU, nxscan_options_menu_create((caddr_t) ip, ip->win),
		PANEL_NOTIFY_PROC, options_handler,
		NULL);
	return obj;
}

/*
 * Create object `message9' in the specified instance.
 */
Xv_opaque
nxscan_win_message9_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 504,
		XV_Y, 8,
		PANEL_LABEL_STRING, "Screen",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `message8' in the specified instance.
 */
Xv_opaque
nxscan_win_message8_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 680,
		XV_Y, 8,
		PANEL_LABEL_STRING, "File",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `message1' in the specified instance.
 */
Xv_opaque
nxscan_win_message1_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 352,
		XV_Y, 24,
		PANEL_LABEL_STRING, "Resolution:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `message5' in the specified instance.
 */
Xv_opaque
nxscan_win_message5_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 488,
		XV_Y, 24,
		PANEL_LABEL_STRING, " 0000 dpi ",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `message2' in the specified instance.
 */
Xv_opaque
nxscan_win_message2_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 656,
		XV_Y, 24,
		PANEL_LABEL_STRING, "100 dpi",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `message3' in the specified instance.
 */
Xv_opaque
nxscan_win_message3_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 352,
		XV_Y, 40,
		PANEL_LABEL_STRING, "Point:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `message4' in the specified instance.
 */
Xv_opaque
nxscan_win_message4_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 480,
		XV_Y, 40,
		PANEL_LABEL_STRING, "00000x00000",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `message6' in the specified instance.
 */
Xv_opaque
nxscan_win_message6_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 632,
		XV_Y, 40,
		PANEL_LABEL_STRING, " 00000x00000 ",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `message7' in the specified instance.
 */
Xv_opaque
nxscan_win_message7_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 64,
		PANEL_LABEL_STRING, "Notes:                                                                                                                                                             .",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `canvas1' in the specified instance.
 */
Xv_opaque
nxscan_win_canvas1_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	extern void	canvas1_repaint();
	Xv_opaque	obj;
	
	obj = xv_create(owner, CANVAS,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, (int)xv_get(ip->controls, XV_Y) +
		      (int)xv_get(ip->controls, XV_HEIGHT),
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, 51,
		CANVAS_REPAINT_PROC, canvas1_repaint,
		CANVAS_X_PAINT_WINDOW, TRUE,
		NULL);
	gcm_initialize_colors(obj, "Black", "White");
	/*
	 * This line is here for backwards compatibility. It will be
	 * removed for the next release.
	 */
	xv_set(canvas_paint_window(obj), XV_KEY_DATA, INSTANCE, ip, NULL);
	return obj;
}

/*
 * Create object `canvas' in the specified instance.
 */
Xv_opaque
nxscan_win_canvas_create(ip, owner)
	nxscan_win_objects	*ip;
	Xv_opaque	owner;
{
	extern Notify_value	canvas_event_nhandler();
	extern void	canvas_repaint();
	extern void	canvas_resize();
	Xv_opaque	obj;
	
	obj = xv_create(owner, CANVAS,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, (int)xv_get(ip->canvas1, XV_Y) +
		      (int)xv_get(ip->canvas1, XV_HEIGHT),
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		CANVAS_REPAINT_PROC, canvas_repaint,
		CANVAS_X_PAINT_WINDOW, TRUE,
		CANVAS_RESIZE_PROC, canvas_resize,
		NULL);
	xv_create(obj, SCROLLBAR, SCROLLBAR_DIRECTION, SCROLLBAR_HORIZONTAL, NULL);
	xv_create(obj, SCROLLBAR, SCROLLBAR_DIRECTION, SCROLLBAR_VERTICAL, NULL);
	gcm_initialize_colors(obj, "Black", "White");
	xv_set(canvas_paint_window(obj), WIN_CONSUME_EVENTS,
		WIN_MOUSE_BUTTONS,
		LOC_MOVE,
		LOC_DRAG,
		LOC_WINENTER,
		LOC_WINEXIT,
		WIN_ASCII_EVENTS,
		WIN_LEFT_KEYS,
		WIN_RIGHT_KEYS,
		WIN_TOP_KEYS,
		NULL, NULL);
	notify_interpose_event_func(canvas_paint_window(obj),
		(Notify_func) canvas_event_nhandler, NOTIFY_SAFE);
	/*
	 * This line is here for backwards compatibility. It will be
	 * removed for the next release.
	 */
	xv_set(canvas_paint_window(obj), XV_KEY_DATA, INSTANCE, ip, NULL);
	return obj;
}

/*
 * Initialize an instance of object `locate_popup'.
 */
nxscan_locate_popup_objects *
nxscan_locate_popup_objects_initialize(ip, owner)
	nxscan_locate_popup_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (nxscan_locate_popup_objects *) calloc(1, sizeof (nxscan_locate_popup_objects))))
		return (nxscan_locate_popup_objects *) NULL;
	if (!ip->locate_popup)
		ip->locate_popup = nxscan_locate_popup_locate_popup_create(ip, owner);
	if (!ip->locate_canvas)
		ip->locate_canvas = nxscan_locate_popup_locate_canvas_create(ip, ip->locate_popup);
	return ip;
}

/*
 * Create object `locate_popup' in the specified instance.
 */
Xv_opaque
nxscan_locate_popup_locate_popup_create(ip, owner)
	nxscan_locate_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 662,
		XV_HEIGHT, 365,
		XV_LABEL, "Locator",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, FALSE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `locate_canvas' in the specified instance.
 */
Xv_opaque
nxscan_locate_popup_locate_canvas_create(ip, owner)
	nxscan_locate_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern Notify_value	locate_canvas_e_handler();
	extern void	locate_canvas_repaint();
	extern void	loc_resize();
	Xv_opaque	obj;
	
	obj = xv_create(owner, CANVAS,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		CANVAS_REPAINT_PROC, locate_canvas_repaint,
		CANVAS_X_PAINT_WINDOW, TRUE,
		CANVAS_RESIZE_PROC, loc_resize,
		NULL);
	gcm_initialize_colors(obj, "Black", "White");
	xv_set(canvas_paint_window(obj), WIN_CONSUME_EVENTS,
		WIN_MOUSE_BUTTONS,
		LOC_MOVE,
		LOC_DRAG,
		LOC_WINENTER,
		LOC_WINEXIT,
		WIN_ASCII_EVENTS,
		WIN_LEFT_KEYS,
		WIN_RIGHT_KEYS,
		WIN_TOP_KEYS,
		NULL, NULL);
	notify_interpose_event_func(canvas_paint_window(obj),
		(Notify_func) locate_canvas_e_handler, NOTIFY_SAFE);
	/*
	 * This line is here for backwards compatibility. It will be
	 * removed for the next release.
	 */
	xv_set(canvas_paint_window(obj), XV_KEY_DATA, INSTANCE, ip, NULL);
	return obj;
}

/*
 * Initialize an instance of object `tools_popup'.
 */
nxscan_tools_popup_objects *
nxscan_tools_popup_objects_initialize(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (nxscan_tools_popup_objects *) calloc(1, sizeof (nxscan_tools_popup_objects))))
		return (nxscan_tools_popup_objects *) NULL;
	if (!ip->tools_popup)
		ip->tools_popup = nxscan_tools_popup_tools_popup_create(ip, owner);
	if (!ip->controls1)
		ip->controls1 = nxscan_tools_popup_controls1_create(ip, ip->tools_popup);
	if (!ip->clear_all_points_but)
		ip->clear_all_points_but = nxscan_tools_popup_clear_all_points_but_create(ip, ip->controls1);
	if (!ip->setting3)
		ip->setting3 = nxscan_tools_popup_setting3_create(ip, ip->controls1);
	if (!ip->setting2)
		ip->setting2 = nxscan_tools_popup_setting2_create(ip, ip->controls1);
	if (!ip->restore_but)
		ip->restore_but = nxscan_tools_popup_restore_but_create(ip, ip->controls1);
	if (!ip->message10)
		ip->message10 = nxscan_tools_popup_message10_create(ip, ip->controls1);
	if (!ip->message11)
		ip->message11 = nxscan_tools_popup_message11_create(ip, ip->controls1);
	if (!ip->message12)
		ip->message12 = nxscan_tools_popup_message12_create(ip, ip->controls1);
	if (!ip->slider2)
		ip->slider2 = nxscan_tools_popup_slider2_create(ip, ip->controls1);
	if (!ip->dig_but1)
		ip->dig_but1 = nxscan_tools_popup_dig_but1_create(ip, ip->controls1);
	if (!ip->undo_user_p)
		ip->undo_user_p = nxscan_tools_popup_undo_user_p_create(ip, ip->controls1);
	if (!ip->undo_add)
		ip->undo_add = nxscan_tools_popup_undo_add_create(ip, ip->controls1);
	return ip;
}

/*
 * Create object `tools_popup' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_tools_popup_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 900,
		XV_HEIGHT, 122,
		XV_LABEL, "Tools",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, FALSE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `controls1' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_controls1_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `clear_all_points_but' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_clear_all_points_but_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		clear_all_points();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 680,
		XV_Y, 96,
		PANEL_LABEL_STRING, "Clear all User Points",
		PANEL_NOTIFY_PROC, clear_all_points,
		NULL);
	return obj;
}

/*
 * Create object `setting3' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_setting3_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		setting1_nhandler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 16,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_CHOOSE_NONE, FALSE,
		PANEL_LABEL_STRING, " Insert/Delete Point mode",
		PANEL_NOTIFY_PROC, setting1_nhandler,
		PANEL_CHOICE_STRINGS,
			"Force Insert",
			"Insert",
			"Delete",
			NULL,
		PANEL_VALUE, 2,
		NULL);
	return obj;
}

/*
 * Create object `setting2' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_setting2_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		add_nhandler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 272,
		XV_Y, 16,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_CHOOSE_NONE, FALSE,
		PANEL_LABEL_STRING, "  Add Pixels:  White/Black",
		PANEL_NOTIFY_PROC, add_nhandler,
		PANEL_CHOICE_STRINGS,
			"192",
			"48",
			"12",
			"3",
			"0",
			"3",
			"12",
			"48",
			"192",
			NULL,
		PANEL_VALUE, 4,
		NULL);
	return obj;
}

/*
 * Create object `restore_but' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_restore_but_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		restore_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 560,
		XV_Y, 96,
		PANEL_LABEL_STRING, "Restore work",
		PANEL_NOTIFY_PROC, restore_handler,
		NULL);
	return obj;
}

/*
 * Create object `message10' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_message10_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 64,
		PANEL_LABEL_STRING, "Use \"select\" (left) button to Insert/Delete Points.",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `message11' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_message11_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 80,
		PANEL_LABEL_STRING, "Use \"menu\" (right) button to Add Pixels.",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `message12' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_message12_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 600,
		XV_Y, 16,
		PANEL_LABEL_STRING, "Digitization curvature, low-high",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `slider2' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_slider2_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		slider_nhandler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_SLIDER,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 600,
		XV_Y, 40,
		PANEL_SLIDER_WIDTH, 100,
		PANEL_TICKS, 11,
		PANEL_DIRECTION, PANEL_HORIZONTAL,
		PANEL_SLIDER_END_BOXES, FALSE,
		PANEL_SHOW_RANGE, TRUE,
		PANEL_SHOW_VALUE, TRUE,
		PANEL_MIN_VALUE, 1,
		PANEL_MAX_VALUE, 100,
		PANEL_VALUE, 75,
		PANEL_NOTIFY_PROC, slider_nhandler,
		NULL);
	return obj;
}

/*
 * Create object `dig_but1' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_dig_but1_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		digitze_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 96,
		PANEL_LABEL_STRING, "Digitize",
		PANEL_NOTIFY_PROC, digitze_handler,
		NULL);
	return obj;
}

/*
 * Create object `undo_user_p' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_undo_user_p_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		undo_user_point();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 120,
		XV_Y, 96,
		PANEL_LABEL_STRING, "Undo Last Point",
		PANEL_NOTIFY_PROC, undo_user_point,
		NULL);
	return obj;
}

/*
 * Create object `undo_add' in the specified instance.
 */
Xv_opaque
nxscan_tools_popup_undo_add_create(ip, owner)
	nxscan_tools_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		undo_add_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 320,
		XV_Y, 96,
		PANEL_LABEL_STRING, "Undo Last Pixel Add/Erase",
		PANEL_NOTIFY_PROC, undo_add_handler,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `user_termpane'.
 */
nxscan_user_termpane_objects *
nxscan_user_termpane_objects_initialize(ip, owner)
	nxscan_user_termpane_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (nxscan_user_termpane_objects *) calloc(1, sizeof (nxscan_user_termpane_objects))))
		return (nxscan_user_termpane_objects *) NULL;
	if (!ip->user_termpane)
		ip->user_termpane = nxscan_user_termpane_user_termpane_create(ip, owner);
	if (!ip->termpane1)
		ip->termpane1 = nxscan_user_termpane_termpane1_create(ip, ip->user_termpane);
	return ip;
}

/*
 * Create object `user_termpane' in the specified instance.
 */
Xv_opaque
nxscan_user_termpane_user_termpane_create(ip, owner)
	nxscan_user_termpane_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 400,
		XV_HEIGHT, 150,
		XV_LABEL, "User Shell",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, FALSE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `termpane1' in the specified instance.
 */
Xv_opaque
nxscan_user_termpane_termpane1_create(ip, owner)
	nxscan_user_termpane_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, TERMSW,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		OPENWIN_SHOW_BORDERS, TRUE,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `save_popup'.
 */
nxscan_save_popup_objects *
nxscan_save_popup_objects_initialize(ip, owner)
	nxscan_save_popup_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (nxscan_save_popup_objects *) calloc(1, sizeof (nxscan_save_popup_objects))))
		return (nxscan_save_popup_objects *) NULL;
	if (!ip->save_popup)
		ip->save_popup = nxscan_save_popup_save_popup_create(ip, owner);
	if (!ip->save_controls_popoup)
		ip->save_controls_popoup = nxscan_save_popup_save_controls_popoup_create(ip, ip->save_popup);
	if (!ip->selection_s_popup)
		ip->selection_s_popup = nxscan_save_popup_selection_s_popup_create(ip, ip->save_controls_popoup);
	if (!ip->save_message_popup)
		ip->save_message_popup = nxscan_save_popup_save_message_popup_create(ip, ip->save_controls_popoup);
	return ip;
}

/*
 * Create object `save_popup' in the specified instance.
 */
Xv_opaque
nxscan_save_popup_save_popup_create(ip, owner)
	nxscan_save_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 853,
		XV_HEIGHT, 60,
		XV_LABEL, "Save Options",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, FALSE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `save_controls_popoup' in the specified instance.
 */
Xv_opaque
nxscan_save_popup_save_controls_popoup_create(ip, owner)
	nxscan_save_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `selection_s_popup' in the specified instance.
 */
Xv_opaque
nxscan_save_popup_selection_s_popup_create(ip, owner)
	nxscan_save_popup_objects	*ip;
	Xv_opaque	owner;
{
	extern void		select_s_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 8,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_CHOOSE_NONE, TRUE,
		PANEL_LABEL_STRING, "Save Format",
		PANEL_NOTIFY_PROC, select_s_callback,
		PANEL_CHOICE_STRINGS,
			"User Points",
			"Raw XY",
			"SAC",
			"NULL",
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `save_message_popup' in the specified instance.
 */
Xv_opaque
nxscan_save_popup_save_message_popup_create(ip, owner)
	nxscan_save_popup_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 296,
		XV_Y, 40,
		PANEL_LABEL_STRING, "                                        ",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

