
#include <stdio.h>
#include <xview/xv_xrect.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

extern XPoint *tr;
extern XPoint *tr2;
extern int tr_n;
extern int curvature;

extern struct image_dat ;
extern set_message7();

static int g_wide;
static int mxval,myval;  /* max permissible values for x,y on image */
static char mstring[256];

static int getwidth ();
static int reverse_trace_section();
static int force_connect();
static int trace_section();
static int predict();
static int smooth();
static int findmid();
static int get_lower();
static int get_upper();

/* the tracing aalgorythm is embassingly simple, but a surprising
   number of more elegant methods fail to acheive the results of
   this simple 'search for the middle of the curve' approach */
trace(im,p,cf,n)
    XImage *im;
    XPoint *p;
    short *cf;
    int n;
{
    int points,i,j,np,lost=0;
    int val;
    fprintf (stderr, "In trace\n"); fflush (stderr);    /*:: debug */
    if(n <= 1) { set_message7("No points to connect??"); 
    fprintf(stderr,"no points to connect ??\n"); return; }
    mxval = im->width;
    myval = im->height;

    if( p[0].x > mxval || p[0].y > myval ) {
	fprintf(stderr,"Error in tracer: point out of bounds \n");  return; }
    if( p[0].x < 0 || p[0].y < 0 ) {
	fprintf(stderr,"Error in tracer: negative point value\n");  return; }
    val = XGetPixel(im,(int) (p[0].x) ,(int) (p[0].y) );
    g_wide = 25;  /* this allows for lines up to about 100 pixels */
    g_wide = getwidth(im,p[0].x,p[0].y,val,g_wide);
    fprintf(stderr,"Begin trace, estimate of line width %d\n",g_wide);
    tr_n = p[n-1].x - p[0].x;
    fprintf(stderr,"tr_n %d, p[n-1] %d, p[0] %d, tr %ld\n",tr_n,p[n-1].x,p[0].x,tr);

/*
  if( tr != NULL )  free( tr );
  if( (tr = (XPoint *) malloc(tr_n * sizeof(XPoint) ) ) == NULL)
  fprintf(stderr,"Malloc returned an error!!\n");
  if( tr2 != NULL )  free( tr2 );
  if( (tr2 = (XPoint *) malloc(tr_n * sizeof(XPoint) ) ) == NULL)
  fprintf(stderr,"Malloc returned an error!!\n");
  */

    points = 0;
    for(i=0;i<(n-1);i++) {
	if( p[i].x > mxval || p[i].y > myval ) {
	    fprintf(stderr,"Error in tracer: \n");  return; }
	if( p[i].x < 0 || p[i].y < 0 ) {
	    fprintf(stderr,"Error in tracer: \n");  return; }
	if(cf[i] == 0) {
	    np = trace_section(im,p[i].x,p[i].y,p[i+1].x,p[i+1].y,tr+points,val);
	    reverse_trace_section(im,p[i].x,p[i].y,p[i+1].x,p[i+1].y,tr2+points+np,val);
	}
/* ERROR *********** if force connect on first seg, then g_wide never set!!! */
	else { 
	    np = force_connect( p[i].x,p[i].y,p[i+1].x,p[i+1].y
				,tr+points,tr2+points); }
	/* note the tr2+points' is important ordering above */
	for( j = 0; j < np/2; j++) {
	    if( (tr+points+j)->y < ( (tr2+points+j)->y - g_wide ) ||
		(tr+points+j)->y > ( (tr2+points+j)->y + g_wide ) ) lost++;
	    else { (tr+points+j)->y = ((tr+points+j)->y + (tr2+points+j)->y )/2; }
	}
	for( ; j < np; j++) {
	    if( (tr+points+j)->y < ( (tr2+points+j)->y - g_wide ) ||
		(tr+points+j)->y > ( (tr2+points+j)->y + g_wide ) ) 
		(tr+points+j)->y = (tr2+points+j)->y;
	    else { (tr+points+j)->y = ((tr+points+j)->y + (tr2+points+j)->y )/2; }
	}
	points += np;
    }
    if( points != tr_n ) {
	fprintf(stderr,"trace point mismatch\n");
	tr_n=0;
    }
    else{ 
	fprintf(stderr,"failure rate %d%% \n",lost*100/points);
	sprintf(mstring,"failure rate %d%% \n",lost*100/points);
	set_message7(mstring);
    }
}

int
getwidth(im,x,y,v,w)
    XImage *im;
    short x,y;
    int v;
    int w;
{
    int i,y_mid;
    int u=0,l=0;
    XPoint temp[10];
    fprintf (stderr, "In getwidth\n"); fflush (stderr);    /*:: debug */
    y_mid = findmid(im,(int)x,(int)y,v);
    trace_section(im,(short) x,(short) y_mid,(short) (x+10),(short) y_mid,temp,v);
    for(i=0;i<10;i++) {
	u+= get_upper(im,(int) (temp[i].x),(int) (temp[i].y),v,w);
	l+= get_lower(im,(int) (temp[i].x),(int) (temp[i]).y,v,w);
    }
    return( (l-u)/10 );
}

int
reverse_trace_section(i,x0,y0,x1,y1,tr,val)
    XImage *i;
    short x0,x1,y0,y1;
    XPoint *tr;
    int val;
{
    int n,k;
    int x,y;
    int y_mid;
    n=x1-x0;
/* fprintf(stderr,"reverse joining segment from %d,%d to %d,%d (val %d) \n"
   ,x1,y1,x0,y0,val);*/
    x=x1; y=y1;
    for(k=0; k < n; k++){
	(tr-k)->x=x;
	y = predict(y,k,-1,tr);
	y_mid = findmid(i,x,y,val);
	y_mid = smooth(y_mid,k,-1,tr);
	(tr-k)->y=y_mid;
	x-=1;
	y = y_mid;
    }
    return(k);
}

int
force_connect(x0,y0,x1,y1,tr,tr2)
    short x0,x1,y0,y1;
    XPoint *tr,*tr2;
{
    int n,k,x,y;
    float m,b;
    n=x1-x0;
    m = (float)(y1-y0)/(float)n;
    b = m*x0-y0;
/* fprintf(stderr,"forcing connect from %d,%d to %d,%d \n",x0,y0,x1,y1); */
    x=x0; y=y0;
    for(k=0; k < n; k++){
	(tr+k)->x=x;
	(tr2+k)->x=x;
	(tr+k)->y= (short) (m*x-b);
	(tr2+k)->y= (tr+k)->y;
	x+=1;
    }
    return(n);
}

int
trace_section(i,x0,y0,x1,y1,tr,val)
    XImage *i;
    short x0,x1,y0,y1;
    XPoint *tr;
    int val;
{
    int n,k;
    int x,y;
    int y_mid;
    n=x1-x0;
/* fprintf(stderr,"joining segment from %d,%d to %d,%d (val %d) \n"
   ,x0,y0,x1,y1,val); */
    x=x0; y=y0;
    for(k=0; k < n; k++){
	(tr+k)->x=x;
	y = predict(y,k,1,tr);
	y_mid = findmid(i,x,y,val);
	y_mid = smooth(y_mid,k,1,tr);
	(tr+k)->y=y_mid;
	x+=1;
	y = y_mid;
    }
    return(k);
}

int
predict(y,k,n,tr)
    int y;
    int k,n;
    XPoint *tr;
{
    int project;
    project = y;
    if( n > 0 ) /* forward connect */ {
	if(k > 2) {
	    project = (tr+k-1)->y - (tr+k-2)->y;
	    project += (tr+k-1)->y;
	}
    }
    else { 
	if(k > 2) {
	    project = (tr-k+1)->y - (tr-k+2)->y;
	    project += (tr-k+1)->y;
	}
    }
    return(project);
}

int
smooth(y,k,n,tr)
    int y;
    int k,n;
    XPoint *tr;
{
    int project;
    int incr ;  /* this is the max curvature of the line */
    incr = curvature;
    if( n > 0 ) /* forward connect */ {
	if(k > 2) {
	    project = (tr+k-1)->y - (tr+k-2)->y;
	    project += (tr+k-1)->y;
	    if( y > (project + incr) ) y = project + incr;
	    if( y < (project - incr) ) y = project - incr;
	}
    }
    else { 
	if(k > 2) {
	    project = (tr-k+1)->y - (tr-k+2)->y;
	    project += (tr-k+1)->y;
	    if( y > (project + incr) ) y = project + incr;
	    if( y < (project - incr) ) y = project - incr;
	}
    }
    return(y);
}

int
findmid(im,x,y,val)
    XImage *im;
    int x,y;
    int val;
{
    int n,w5;
    int near = 0;
    int upper,lower;
    w5 = g_wide*15;

    if( y > myval ) y = myval; 
    if( x > mxval ) x = mxval; 
    if( y < 0 ) y = 0; 
    if( x < 0 ) x = 0; 

    if( (int) XGetPixel(im,x,y) == val ) near = 1;

/* find a pixel of value = val */
    if( near == 0) 
	for (n=1; n < w5; n++) {
	    if( y+n > myval ) break; 
	    if( (int) XGetPixel(im,x,y+n) == val ) { near = 1; y +=n; break; }
	    if( y-n < 0 ) break; 
	    if( (int) XGetPixel(im,x,y-n) == val ) { near = 1; y -=n; break; }
	}
    if( near == 0) return(y);

/* find midle of region */
    upper = get_upper(im,x,y,val,g_wide);
    lower = get_lower(im,x,y,val,g_wide);

    return( lower + (upper-lower)/2 );
}

int
get_lower(im,x,y,v,w)
    XImage *im;
    int x,y,v;
    int w;
{
    int n,w5,lower;
    lower = y;

    w5=w*25;
    for( n=1; n<w5; n++) {
	if( x > mxval ) x = mxval;
	if( y+n > myval ) { lower = y+n-1; break; }
	if( (int) XGetPixel(im,x,y+n) != v ) { lower = y+n; break; }
    }
    return( lower);
}

int
get_upper(im,x,y,v,w)
    XImage *im;
    int x,y,v;
    int w;
{
    int n,w5;
    int upper;
    upper = y;

    w5=w*25;
    for( n=1; n<w5; n++) 
    {
	if( y-n < 0 ) { upper = y-n+1; break; }
	if( (int) XGetPixel(im,x,y-n) != v ) { upper = y-n; break; }
    }
    return( upper);
}
